;;; DO NOT MODIFY THIS FILE
(if (featurep 'modules-autoloads) (error "Feature modules-autoloads already loaded"))

;;;### (autoloads (ase-cartesian* ase-cartesian) "ase-cartesian" "ase/ase-cartesian.c")

(autoload 'ase-cartesian "ase-cartesian" "\
Return a cartesian (exterior) product of OBJECTS." nil nil)

(autoload 'ase-cartesian* "ase-cartesian" "\
Return an interior cartesian product of OBJECTS." nil nil)

;;;***

;;;### (autoloads (ase-digraph) "ase-digraph" "ase/ase-digraph.c")

(autoload 'ase-digraph "ase-digraph" "\
Return an empty directed graph." nil nil)

;;;***

;;;### (autoloads (ase-heap) "ase-heap" "ase/ase-heap.c")

(autoload 'ase-heap "ase-heap" "\
Return a new heap object.

Arguments: &rest keys
:kind  kind of the heap, can be one of 'weak (default), 'dense, or 'dynamic
:relation" nil nil)

;;;***

;;;### (autoloads (ase-interval ase-universe-interval ase-empty-interval) "ase-interval" "ase/ase-interval.c")

(autoload 'ase-empty-interval "ase-interval" "\
Return the empty interval." nil nil)

(autoload 'ase-universe-interval "ase-interval" "\
Return the universe interval." nil nil)

(autoload 'ase-interval "ase-interval" "\
Return a (primitive) interval with lower bound LOWER and upper bound UPPER.
To construct a (degenerated) one point interval, leave out the UPPER part.

ASE's definition of an interval:
With respect to a (strict) partial order, an interval is a connected
subset of a poset.

If no special partial order is given, it defaults to less-equal-p (<=).
If no special topology is given, it defaults to the po topology." nil nil)

;;;***

;;;### (autoloads (ase-metric ase-p-metric* ase-p-metric) "ase-metric" "ase/ase-metric.c")

(autoload 'ase-p-metric "ase-metric" "\
Return a p-metric for some natural number P." nil nil)

(autoload 'ase-p-metric* "ase-metric" "\
Return a p-metric without the final root for some natural number P." nil nil)

(autoload 'ase-metric "ase-metric" "\
Return a metric from a distance function FN.

FN should take two arguments and return the distance between those,
a distance by definition lives in the reals." nil nil)

;;;***

;;;### (autoloads (ase-neighbourhood) "ase-neighbourhood" "ase/ase-neighbourhood.c")

(autoload 'ase-neighbourhood "ase-neighbourhood" "\
Return a neighbourhood around with POINT of radius RADIUS
with respect to METRIC (optional).

If no special metric is given, the supremum metric is used." nil nil)

;;;***

;;;### (autoloads (ase-permutation) "ase-permutation" "ase/ase-permutation.c")

(autoload 'ase-permutation "ase-permutation" "\
Return a permutation around with POINT of radius RADIUS
with respect to METRIC (optional).

If no special metric is given, the supremum metric is used." nil nil)

;;;***

;;;### (autoloads (residue-class-p residue-class-ring-p residue-class-ring make-residue-class make-residue-class-ring) "ase-resclass" "ase/ase-resclass.c")

(autoload 'make-residue-class-ring "ase-resclass" "\
Return a residue class ring of size MODULUS (>= 2)." nil nil)

(autoload 'make-residue-class "ase-resclass" "\
Return the residue class of ELEMENT in RING." nil nil)

(autoload 'residue-class-ring "ase-resclass" "\
Return the parental residue class ring (the world) of RESCLASS." nil nil)

(autoload 'residue-class-ring-p "ase-resclass" "\
Return t if OBJECT is a residue class ring, nil otherwise." nil nil)

(autoload 'residue-class-p "ase-resclass" "\
Return t if OBJECT is a residue class, nil otherwise." nil nil)

;;;***

;;;### (autoloads (cl:do-all-symbols cl:do-symbols cl:dolist cl:dotimes cl:do* cl:do cl:loop-sentence) "cl-loop" "cl/cl-loop.c")

(autoload 'cl:loop-sentence "cl-loop" "\
The Common Lisp loop macro." nil nil)

(autoload 'cl:do "cl-loop" "\
The Common Lisp `do' loop.
Format is: (do ((VAR INIT [STEP])...) (END-TEST [RESULT...]) BODY...)" nil nil)

(autoload 'cl:do* "cl-loop" "\
The Common Lisp `do' loop.
Format is: (do* ((VAR INIT [STEP])...) (END-TEST [RESULT...]) BODY...)" nil nil)

(autoload 'cl:dotimes "cl-loop" "\
The Common Lisp `dotimes' loop.
Format is: (dotimes (VAR COUNT [RESULT]) BODY...)" nil nil)

(autoload 'cl:dolist "cl-loop" "\
The Common Lisp `dolist' loop.
Format is: (dolist (VAR LIST [RESULT]) BODY...)" nil nil)

(autoload 'cl:do-symbols "cl-loop" "\
The Common Lisp `dolist' loop.
Format is: (do-symbols (VAR [OBARRAY [RESULT]]) BODY...)" nil nil)

(autoload 'cl:do-all-symbols "cl-loop" "\
The Common Lisp `dolist' loop.
Format is: (do-all-symbols (VAR [RESULT]) BODY...)" nil nil)

;;;***

;;;### (autoloads (cl:ldiff cl:tailp cl:list* cl:eql cl:pushnew cl:push cl:pop) "cl" "cl/cl.c")

(autoload 'cl:pop "cl" "\

" nil nil)

(autoload 'cl:push "cl" "\

" nil nil)

(autoload 'cl:pushnew "cl" "\

" nil nil)

(autoload 'cl:eql "cl" "\

" nil nil)

(autoload 'cl:list* "cl" "\

" nil nil)

(autoload 'cl:tailp "cl" "\

" nil nil)

(autoload 'cl:ldiff "cl" "\

" nil nil)

;;;***

(provide 'modules-autoloads)
