;;; DO NOT MODIFY THIS FILE
(if (featurep 'auto-custom-defines) (error "Feature auto-custom-defines already loaded"))

;;;### (autoloads (only-global-abbrevs abbrev-mode abbrev) "abbrev" "lisp/abbrev.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/abbrev.el")

(defgroup abbrev nil "Abbreviation handling, typing shortcuts, macros." :tag "Abbreviations" :group 'editing)

(defgroup abbrev-mode nil "Word abbreviations mode." :group 'abbrev)

(defcustom only-global-abbrevs nil "\
*Non-nil means user plans to use global abbrevs only.
Makes the commands to define mode-specific abbrevs define global ones instead." :type 'boolean :group 'abbrev)

;;;***

;;;### (autoloads (apropos-rewrite-regexps) "apropos" "lisp/apropos.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/apropos.el")

(defcustom apropos-rewrite-regexps nil "\
*Non-nil mean regexps with spaces are rewritten to match all words permutations." :type 'boolean)

;;;***

;;;### (autoloads (auto-save-offer-delete auto-save-hash-p auto-save-directory auto-save) "auto-save" "lisp/auto-save.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/auto-save.el")

(defgroup auto-save nil "Autosaving with support for efs and /tmp." :group 'data)

(defcustom auto-save-directory nil "\
If non-nil, fixed directory for autosaving: all autosave files go
there.  If this directory does not yet exist at load time, it is
created and its mode is set to 0700 so that nobody else can read your
autosave files.

If nil, each autosave files goes into the same directory as its
corresponding visited file.

A non-nil `auto-save-directory' could be on a local disk such as in
/tmp, then auto-saves will always be fast, even if NFS or the
automounter is slow.  In the usual case of /tmp being locally mounted,
note that if you run emacs on two different machines, they will not
see each other's auto-save files.

The value (expand-file-name \"~/.autosave/\") might be better if /tmp
is mounted from swap (possible in SunOS, type `df /tmp' to find out)
and thus vanishes after a reboot, or if your system is particularly
thorough when cleaning up /tmp, clearing even non-empty subdirectories.

It should never be an efs remote filename because that would
defeat `efs-auto-save-remotely'.

Unless you set `auto-save-hash-p', you shouldn't set this to a
directory in a filesystem that does not support long filenames, since
a file named

    /home/sk/lib/emacs/lisp/auto-save.el

will have a longish filename like

    AUTO-SAVE-DIRECTORY/#=2Fhome=2Fsk=2Flib=2Femacs=2Flisp=2Fauto-save.el#

as auto save file.

See also variables `auto-save-directory-fallback',
`efs-auto-save' and `efs-auto-save-remotely'." :type '(choice (const :tag "Same as file" nil) directory) :group 'auto-save)

(defcustom auto-save-hash-p nil "\
If non-nil, hashed autosave names of length 14 are used.
This is to avoid autosave filenames longer than 14 characters.
The directory used is `auto-save-hash-directory' regardless of
`auto-save-directory'.
Hashing defeats `recover-all-files', you have to recover files
individually by doing `recover-file'." :type 'boolean :group 'auto-save)

(defcustom auto-save-offer-delete nil "\
*If non-nil, `recover-all-files' offers to delete autosave files
that are out of date or were dismissed for recovering.
Special value 'always deletes those files silently." :type '(choice (const :tag "on" t) (const :tag "off" nil) (const :tag "Delete silently" always)) :group 'auto-save)

;;;***

;;;### (autoloads (auto-show-show-left-margin-threshold auto-show-shift-amount auto-show-mode auto-show) "auto-show" "lisp/auto-show.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/auto-show.el")

(defgroup auto-show nil "Perform automatic horizontal scrolling as point moves." :group 'display :group 'extensions)

(defcustom auto-show-mode t "\
*Non-nil enables automatic horizontal scrolling, when lines are truncated.
The default value is t.  To change the default, do this:
	(set-default 'auto-show-mode nil)
See also command `auto-show-mode'.
This variable has no effect when lines are not being truncated.
This variable is automatically local in each buffer where it is set." :type 'boolean :group 'auto-show)

(defcustom auto-show-shift-amount 8 "\
*Extra columns to scroll. for automatic horizontal scrolling." :type 'integer :group 'auto-show)

(defcustom auto-show-show-left-margin-threshold 50 "\
*Threshold column for automatic horizontal scrolling to the right.
If point is before this column, we try to scroll to make the left margin
visible.  Setting this to 0 disables this feature." :type 'number :group 'auto-show)

;;;***

;;;### (autoloads (build-rpt-use-gnus-plugged build-rpt-use-gnus-group build-rpt-use-gnus-p build-rpt-file-encoding build-rpt-prompts build-rpt-subject build-rpt-version-file build-rpt-installation-file build-rpt-make-output-files build-rpt-make-output-dir build-rpt-delete-regexp build-rpt-keep-regexp build-rpt-destination build-rpt) "build-rpt" "lisp/build-rpt.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/build-rpt.el")

(defgroup build-rpt nil "Standardises the Creation of SXEmacs Build Rpts." :load 'build-rpt :group 'build)

(defcustom build-rpt-destination (list "SXEmacs Build Reports <sxemacs-builds@sxemacs.org>" "SXEmacs Devel <sxemacs-devel@sxemacs.org>" "Steve Youngs <steve@sxemacs.org>") "\
*The list of mail addresses SXEmacs Build Reports should most likely
go to." :type '(repeat :custom-show t :documentation-shown t string) :group 'build-rpt)

(defcustom build-rpt-keep-regexp (list "^\\(cd\\|n?make\\)\\s-" "errors?" "warnings?" "pure.*\\(space\\|size\\)" "hides\\b" "strange" "shadowings" "^Compil\\(ing\\s-+in\\|ation\\)" "^Using" "not\\s-+found" "^While\\s-+compiling.*\\(\n\\s-+.+\\)*" "^Note:" "Installing" "[Ff]ile(s) copied" "^[A-Za-z_]+=" "\\s-+tests\\s-+" "^\\(real\\|user\\|sys\\)\\s-+[0-9]+m") "\
*Regexp of make process output lines to keep in the report." :type '(repeat :custom-show t :documentation-shown t regexp) :group 'build-rpt)

(defcustom build-rpt-delete-regexp (list "confl.*with.*auto-inlining" "^Formatting:" "(100%) tests successful" "errors that should" "wrong-error") "\
*Regexp of make process output lines to delete from the report." :type '(repeat :custom-show t :documentation-shown t regexp) :group 'build-rpt)

(defcustom build-rpt-make-output-dir (config-value 'sxe_blddir) "\
*Directory where the build report file is found." :type '(directory :custom-show t :documentation-shown t) :group 'build-rpt)

(defcustom build-rpt-make-output-files (list ",,vars.out" ",,beta.out" ",,make-all.out" ",,make-check-temacs.out" ",,make-check.out" ",,make-install.out") "\
*List of Filenames where stdout and stderr of SXEmacs make process
have been stored.  These are relative to
`build-rpt-make-output-dir`.  You'll have to run make with output
redirection, like so...

  $ make 2>&1 | tee ,,make-all.out
  $ make check 2>&1 | tee ,,make-check.out
" :type '(repeat :custom-show t :documentation-shown t file) :group 'build-rpt)

(defcustom build-rpt-installation-file (expand-file-name "Installation" (gethash 'sxe_blddir (config-value-hash-table))) "\
*Installation file produced by SXEmacs configure process." :type '(file :custom-show t :documentation-shown t) :group 'build-rpt)

(defcustom build-rpt-version-file (expand-file-name "config.h" (file-name-as-directory (paths-construct-path (list (gethash 'sxe_blddir (config-value-hash-table)) "src")))) "\
*File containing version info." :type '(file :custom-show t :documentation-shown t) :group 'build-rpt)

(defcustom build-rpt-subject (concat "[%s] " (gethash 'SXEMACS_GIT_VERSION (config-value-hash-table)) " on " system-configuration) "\
*SXEmacs Build Report Subject Line. %s-sequences will be substituted
  with user input through `build-rpt' according to
  `build-rpt-prompts' using `format'." :type '(string :custom-show t :documentation-shown t) :group 'build-rpt)

(defcustom build-rpt-prompts '(("Status?: " ("Success" "Tests fail" "Failure" "Vanilla problems" "Problems"))) "\
*SXEmacs Build Report Prompt(s). This is a list of prompt-string
  lists used by `build-rpt' in conjunction with
  `build-rpt-subject'. Each list consists of a prompt string
  followed by any number of strings which can be chosen via the history
  mechanism." :type '(repeat :custom-show t :documentation-shown t (list :tag "Prompt" string (repeat :tag "Values" string))) :group 'build-rpt)

(defcustom build-rpt-file-encoding "7bit" "\
*SXEmacs Build Report File Encoding to be used when MIME support is
  available." :group 'build-rpt)

(defcustom build-rpt-use-gnus-p nil "\
*Whether the SXEmacs Build Report should be set up by Gnus.
Note that Gnus has to be fully started, i.e. there has to be a
*Group* buffer" :group 'build-rpt :type 'boolean)

(defcustom build-rpt-use-gnus-group "" "\
*Name of a group in the group buffer to send the build report from.
This is useful if there are customised settings along with the group." :type 'string :group 'build-rpt)

(defcustom build-rpt-use-gnus-plugged t "\
*When non-nil, start Gnus in \"plugged\" mode if it isn't running." :type 'boolean :group 'build-rpt)

;;;***

;;;### (autoloads (teach-extended-commands-timeout teach-extended-commands-p errors-deactivate-region) "cmdloop" "lisp/cmdloop.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/cmdloop.el")

(defcustom errors-deactivate-region nil "\
*Non-nil means that errors will cause the region to be deactivated." :type 'boolean :group 'editing-basics)

(defcustom teach-extended-commands-p t "\
*If true, then `\\[execute-extended-command]' will teach you keybindings.
Any time you execute a command with \\[execute-extended-command] which has a
shorter keybinding, you will be shown the alternate binding before the
command executes.  There is a short pause after displaying the binding,
before executing it; the length can be controlled by
`teach-extended-commands-timeout'." :type 'boolean :group 'keyboard)

(defcustom teach-extended-commands-timeout 4 "\
*How long to pause after displaying a keybinding before executing.
The value is measured in seconds.  This only applies if
`teach-extended-commands-p' is true." :type 'number :group 'keyboard)

;;;***

;;;### (autoloads (custom-mode-hook custom-group-tag-faces custom-face-default-form custom-variable-default-form custom-magic-show-button custom-magic-show-hidden custom-magic-show custom-magic-faces custom-display-global-buttons custom-novice custom-reset-button-menu custom-buffer-indent custom-buffer-done-function custom-buffer-style custom-menu-order-groups custom-menu-sort-alphabetically custom-buffer-order-groups custom-buffer-sort-alphabetically custom-browse-only-groups custom-browse-order-groups custom-browse-sort-alphabetically custom-guess-doc-alist custom-guess-name-alist custom-unlispify-tag-names custom-unlispify-remove-prefixes custom-unlispify-menu-entries custom-save-pretty-print mule debug limits installation display editing-basics undo alloc custom-menu custom-buffer custom-browse custom-faces customize local hypermedia tex wp data i18n unix terminals hardware comm environment maint internal extensions docs development games news mail calendar applications oop tools c languages programming bib external outlines emulations matching editing emacs) "cus-edit" "lisp/cus-edit.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/cus-edit.el")

(defgroup emacs nil "Customization of the One True Editor." :link '(custom-manual "(XEmacs)Top"))

(defgroup editing nil "Basic text editing facilities." :group 'emacs)

(defgroup matching nil "Various sorts of searching and matching." :group 'editing)

(defgroup emulations nil "Emulations of other editors." :group 'editing)

(defgroup outlines nil "Support for hierarchical outlining." :group 'editing)

(defgroup external nil "Interfacing to external utilities." :group 'emacs)

(defgroup bib nil "Code related to the `bib' bibliography processor." :tag "Bibliography" :group 'external)

(defgroup programming nil "Support for programming in other languages." :group 'emacs)

(defgroup languages nil "Specialized modes for editing programming languages." :group 'programming)

(defgroup c nil "Support for the C language and related languages." :group 'languages)

(defgroup tools nil "Programming tools." :group 'programming)

(defgroup oop nil "Support for object-oriented programming." :group 'programming)

(defgroup applications nil "Applications written in Emacs." :group 'emacs)

(defgroup calendar nil "Calendar and time management support." :group 'applications)

(defgroup mail nil "Modes for electronic-mail handling." :group 'applications)

(defgroup news nil "Support for netnews reading and posting." :group 'applications)

(defgroup games nil "Games, jokes and amusements." :group 'applications)

(defgroup development nil "Support for further development of Emacs." :group 'emacs)

(defgroup docs nil "Support for Emacs documentation." :group 'development)

(defgroup extensions nil "Emacs Lisp language extensions." :group 'development)

(defgroup internal nil "Code for Emacs internals, build process, defaults." :group 'development)

(defgroup maint nil "Maintenance aids for the Emacs development group." :tag "Maintenance" :group 'development)

(defgroup environment nil "Fitting Emacs with its environment." :group 'emacs)

(defgroup comm nil "Communications, networking, remote access to files." :tag "Communication" :group 'environment)

(defgroup hardware nil "Support for interfacing with exotic hardware." :group 'environment)

(defgroup terminals nil "Support for terminal types." :group 'environment)

(defgroup unix nil "Front-ends/assistants for, or emulators of, UNIX features." :group 'environment)

(defgroup i18n nil "Internationalization and alternate character-set support." :group 'environment :group 'editing)

(defgroup data nil "Support editing files of data." :group 'emacs)

(defgroup wp nil "Word processing." :group 'emacs)

(defgroup tex nil "Code related to the TeX formatter." :group 'wp)

(defgroup hypermedia nil "Support for links between text or other media types." :group 'emacs)

(defgroup local nil "Code local to your site." :group 'emacs)

(defgroup customize '((widgets custom-group)) "Customization of the Customization support." :link '(custom-manual "(custom)Top") :link '(url-link :tag "Development Page" "http://www.dina.kvl.dk/~abraham/custom/") :prefix "custom-" :group 'help)

(defgroup custom-faces nil "Faces used by customize." :group 'customize :group 'faces)

(defgroup custom-browse nil "Control customize browser." :prefix "custom-" :group 'customize)

(defgroup custom-buffer nil "Control customize buffers." :prefix "custom-" :group 'customize)

(defgroup custom-menu nil "Control customize menus." :prefix "custom-" :group 'customize)

(defgroup alloc nil "Storage allocation and gc for XEmacs Lisp interpreter." :tag "Storage Allocation" :group 'internal)

(defgroup undo nil "Undoing changes in buffers." :group 'editing)

(defgroup editing-basics nil "Most basic editing facilities." :group 'editing)

(defgroup display nil "How characters are displayed in buffers." :group 'environment)

(defgroup installation nil "The Emacs installation." :group 'environment)

(defgroup limits nil "Internal Emacs limits." :group 'internal)

(defgroup debug nil "Debugging Emacs itself." :group 'development)

(defgroup mule nil "Mule XEmacs internationalization." :group 'i18n)

(defcustom custom-save-pretty-print t "\
Non-nil means pretty-print values of customized variables if available." :group 'customize :type 'boolean)

(defcustom custom-unlispify-menu-entries t "\
Display menu entries as words instead of symbols if non nil." :group 'custom-menu :type 'boolean)

(defcustom custom-unlispify-remove-prefixes t "\
Non-nil means remove group prefixes from option names in buffers and menus.
This only has an effect when `custom-unlispify-tag-names' or
`custom-unlispify-menu-entries' is on." :group 'custom-menu :type 'boolean)

(defcustom custom-unlispify-tag-names t "\
Display tag names as words instead of symbols if non nil." :group 'custom-buffer :type 'boolean)

(defcustom custom-guess-name-alist '(("-p\\'" boolean) ("-hooks?\\'" hook) ("-face\\'" face) ("-file\\'" file) ("-function\\'" function) ("-functions\\'" (repeat function)) ("-list\\'" (repeat sexp)) ("-alist\\'" (repeat (cons sexp sexp)))) "\
Alist of (MATCH TYPE).

MATCH should be a regexp matching the name of a symbol, and TYPE should
be a widget suitable for editing the value of that symbol.  The TYPE
of the first entry where MATCH matches the name of the symbol will be
used.

This is used for guessing the type of variables not declared with
customize." :type '(repeat (group (regexp :tag "Match") (sexp :tag "Type"))) :group 'customize)

(defcustom custom-guess-doc-alist '(("\\`\\*?Non-nil " boolean)) "\
Alist of (MATCH TYPE).

MATCH should be a regexp matching a documentation string, and TYPE
should be a widget suitable for editing the value of a variable with
that documentation string.  The TYPE of the first entry where MATCH
matches the name of the symbol will be used.

This is used for guessing the type of variables not declared with
customize." :type '(repeat (group (regexp :tag "Match") (sexp :tag "Type"))) :group 'customize)

(defcustom custom-browse-sort-alphabetically nil "\
If non-nil, sort members of each customization group alphabetically." :type 'boolean :group 'custom-browse)

(defcustom custom-browse-order-groups nil "\
If non-nil, order group members within each customization group.
If `first', order groups before non-groups.
If `last', order groups after non-groups." :type '(choice (const first) (const last) (const :tag "none" nil)) :group 'custom-browse)

(defcustom custom-browse-only-groups nil "\
If non-nil, show group members only within each customization group." :type 'boolean :group 'custom-browse)

(defcustom custom-buffer-sort-alphabetically nil "\
If non-nil, sort members of each customization group alphabetically." :type 'boolean :group 'custom-buffer)

(defcustom custom-buffer-order-groups 'last "\
If non-nil, order group members within each customization group.
If `first', order groups before non-groups.
If `last', order groups after non-groups." :type '(choice (const first) (const last) (const :tag "none" nil)) :group 'custom-buffer)

(defcustom custom-menu-sort-alphabetically nil "\
If non-nil, sort members of each customization group alphabetically." :type 'boolean :group 'custom-menu)

(defcustom custom-menu-order-groups 'first "\
If non-nil, order group members within each customization group.
If `first', order groups before non-groups.
If `last', order groups after non-groups." :type '(choice (const first) (const last) (const :tag "none" nil)) :group 'custom-menu)

(defcustom custom-buffer-style 'links "\
*Control the presentation style for customization buffers.
The value should be a symbol, one of:

brackets: groups nest within each other with big horizontal brackets.
links: groups have links to subgroups." :type '(radio (const :tag "brackets: Groups nest within each others" brackets) (const :tag "links: Group have links to subgroups" links)) :group 'custom-buffer)

(defcustom custom-buffer-done-function 'kill-buffer "\
*Function to be used to remove the buffer when the user is done with it.
Choices include `kill-buffer' (the default) and `bury-buffer'.
The function will be called with one argument, the buffer to remove." :type '(radio (function-item kill-buffer) (function-item bury-buffer) (function :tag "Other" nil)) :group 'custom-buffer)

(defcustom custom-buffer-indent 3 "\
Number of spaces to indent nested groups." :type 'integer :group 'custom-buffer)

(defcustom custom-reset-button-menu t "\
If non-nil, only show a single reset button in customize buffers.
This button will have a menu with all three reset operations." :type 'boolean :group 'custom-buffer)

(defcustom custom-novice t "\
If non-nil, show help message at top of customize buffers." :type 'boolean :group 'custom-buffer)

(defcustom custom-display-global-buttons 'top "\
If `nil' don't display the global buttons.  If `top' display at the
beginning of custom buffers.  If `bottom', display at the end." :type '(choice (const top) (const bottom) (const :tag "don't" nil)) :group 'custom-buffer)

(defgroup custom-magic-faces nil "Faces used by the magic button." :group 'custom-faces :group 'custom-buffer)

(defcustom custom-magic-show 'long "\
If non-nil, show textual description of the state.
If `long', show a full-line description, not just one word." :type '(choice (const :tag "no" nil) (const short) (const long)) :group 'custom-buffer)

(defcustom custom-magic-show-hidden '(option face) "\
Control whether the State button is shown for hidden items.
The value should be a list with the custom categories where the State
button should be visible.  Possible categories are `group', `option',
and `face'." :type '(set (const group) (const option) (const face)) :group 'custom-buffer)

(defcustom custom-magic-show-button nil "\
Show a \"magic\" button indicating the state of each customization option." :type 'boolean :group 'custom-buffer)

(defcustom custom-variable-default-form 'edit "\
Default form of displaying variable values." :type '(choice (const edit) (const lisp)) :group 'custom-buffer)

(defcustom custom-face-default-form 'selected "\
Default form of displaying face definition." :type '(choice (const all) (const selected) (const lisp)) :group 'custom-buffer)

(defcustom custom-group-tag-faces nil "\
Face used for group tags.
The first member is used for level 1 groups, the second for level 2,
and so forth.  The remaining group tags are shown with
`custom-group-tag-face'." :type '(repeat face) :group 'custom-faces)

(defcustom custom-mode-hook nil "\
Hook called when entering custom-mode." :type 'hook :group 'custom-buffer)

;;;***

;;;### (autoloads (dragdrop-drop-log-name dragdrop-drop-log dnd-debug experimental-dragdrop-drop-functions dragdrop-autoload-tm-view dragdrop-drop-at-point drag-n-drop) "dragdrop" "lisp/dragdrop.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/dragdrop.el")

(defgroup drag-n-drop nil "*{EXPERIMENTAL} Window system-independent drag'n'drop support." :group 'editing)

(defcustom dragdrop-drop-at-point nil "\
*{EXPERIMENTAL} If non-nil, drop text at the cursor location.
Otherwise, the cursor will be moved to the location of the pointer drop before
text is inserted." :type 'boolean :group 'drag-n-drop)

(defcustom dragdrop-autoload-tm-view nil "\
*{EXPERIMENTAL} If non-nil, autoload tm-view to decode MIME data.
Otherwise, the buffer is only decoded if tm-view is already available." :type 'boolean :group 'drag-n-drop)

(defcustom experimental-dragdrop-drop-functions '((experimental-dragdrop-drop-url-default t t) (experimental-dragdrop-drop-mime-default t t)) "\
*{EXPERIMENTAL} This is the standart drop function search list.
Each element is a list of a function, a button selector, a modifier
selector and optional argumets to the function call.
The function must accept at least two arguments: first is the event
of the drop, second the object data, followed by any of the optional
arguments provided in this list.
The functions are called in order, until one returns t." :group 'drag-n-drop :type '(repeat dragdrop-function-widget))

(defgroup dnd-debug nil "*{EXPERIMENTAL} Drag'n'Drop debugging options." :group 'drag-n-drop)

(defcustom dragdrop-drop-log nil "\
*{EXPERIMENTAL} If non-nil, every drop is logged.
The name of the buffer is set in the custom 'dragdrop-drop-log-name" :group 'dnd-debug :type 'boolean)

(defcustom dragdrop-drop-log-name "*drop log buffer*" "\
*{EXPERIMENTAL} The name of the buffer used to log drops.
Set dragdrop-drop-log to non-nil to enable this feature." :group 'dnd-debug :type 'string)

;;;***

;;;### (autoloads (tag-mark-stack-max find-tag-hook tags-exuberant-ctags-optimization-p tags-check-parent-directories-for-tag-files tags-search-nuke-uninteresting-buffers make-tags-files-invisible tags-auto-read-changed-tag-files tag-table-alist tags-always-exact tags-build-completion-table etags) "etags" "lisp/etags.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/etags.el")

(defgroup etags nil "Etags facility for Emacs.\n\nThis lib provides some useful tools for working with TAGS tables\nthat were created with the etags binary (also distributed with this\nemacs)." :prefix "tags-" :group 'tools)

(defcustom tags-build-completion-table t "\
*When non-nil, build a completion table from all known tags.
Otherwise disable tag completion." :type 'boolean :group 'etags)

(defcustom tags-always-exact nil "\
*If this variable is non-nil, then tags always looks for exact matches.
If it is nil (the default), tags will first go through exact matches,
then through the non-exact ones." :type 'boolean :group 'etags)

(defcustom tag-table-alist nil "\
*A list which determines which tags files are active for a buffer.
This is not really an association list, in that all elements are
checked.  The CAR of each element of this list is a pattern against
which the buffer's file name is compared; if it matches, then the CDR
of the list should be the name of the tags table to use.  If more than
one element of this list matches the buffer's file name, then all of
the associated tags tables will be used.  Earlier ones will be
searched first.

If the CAR of elements of this list are strings, then they are treated
as regular-expressions against which the file is compared (like the
auto-mode-alist).  If they are not strings, then they are evaluated.
If they evaluate to non-nil, then the current buffer is considered to
match.

If the CDR of the elements of this list are strings, then they are
assumed to name a TAGS file.  If they name a directory, then the string
\"TAGS\" is appended to them to get the file name.  If they are not
strings, then they are evaluated, and must return an appropriate string.

For example:
  (setq tag-table-alist
	'((\"/usr/src/public/perl/\" . \"/usr/src/public/perl/perl-3.0/\")
	 (\"\\\\.el$\" . \"/usr/local/emacs/src/\")
	 (\"/jbw/gnu/\" . \"/usr15/degree/stud/jbw/gnu/\")
	 (\"\" . \"/usr/local/emacs/src/\")
	 ))

This means that anything in the /usr/src/public/perl/ directory should use
the TAGS file /usr/src/public/perl/perl-3.0/TAGS; and file ending in .el should
use the TAGS file /usr/local/emacs/src/TAGS; and anything in or below the
directory /jbw/gnu/ should use the TAGS file /usr15/degree/stud/jbw/gnu/TAGS.
A file called something like \"/usr/jbw/foo.el\" would use both the TAGS files
/usr/local/emacs/src/TAGS and /usr15/degree/stud/jbw/gnu/TAGS (in that order)
because it matches both patterns.

If the buffer-local variable `buffer-tag-table' is set, then it names a tags
table that is searched before all others when find-tag is executed from this
buffer.

If there is a file called \"TAGS\" in the same directory as the file in
question, then that tags file will always be used as well (after the
`buffer-tag-table' but before the tables specified by this list.)

If the variable tags-file-name is set, then the tags file it names will apply
to all buffers (for backwards compatibility.)  It is searched first." :type '(repeat (cons :format "%v" (choice :value "" (regexp :tag "Buffer regexp") sexp) (choice :value "" (string :tag "Tag file or directory") sexp))) :group 'etags)

(defcustom tags-auto-read-changed-tag-files nil "\
*If non-nil, always re-read changed TAGS file without prompting.
If nil, prompt whether to re-read the changed TAGS file." :type 'boolean :group 'etags)

(defcustom make-tags-files-invisible nil "\
*If non-nil, TAGS-files will not show up in buffer-lists or be
selectable (or deletable.)" :type 'boolean :group 'etags)

(defcustom tags-search-nuke-uninteresting-buffers t "\
*If non-nil, keep newly-visited files if they contain the search target.
This affects the `tags-search' and `tags-query-replace' commands." :type 'boolean :group 'etags)

(defcustom tags-check-parent-directories-for-tag-files t "\
*If non-nil, look for TAGS files in all parent directories." :type 'boolean :group 'etags)

(defcustom tags-exuberant-ctags-optimization-p nil "\
*If this variable is nil (the default), then exact tag search is able
to find tag names in the name part of the tagtable (enclosed by  ^?..^A)
and in the sourceline part of the tagtable ( enclosed by ^..^?).
This is needed by xemacs etags as not every tag has a name field.
It is slower for large tables and less precise than the other option.

If it is non-nil, then exact tag will only search tag names in the name
part (enclosed by ^?..^A). This is faster and more precise than the other
option. This is only usable with exuberant etags, as it has a name field
entry for every tag." :type 'boolean :group 'etags)

(defcustom find-tag-hook nil "\
*Hook called after a tag is found." :type 'hook :group 'etags)

(defcustom tag-mark-stack-max 16 "\
*The maximum number of elements kept on the mark-stack used
by tags-search.  See also the commands `\\[push-tag-mark]' and
and `\\[pop-tag-mark]'." :type 'integer :group 'etags)

;;;***

;;;### (autoloads (init-face-from-resources frame-background-mode face-frob-from-locale-first faces) "faces" "lisp/faces.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/faces.el")

(defgroup faces nil "Support for multiple text attributes (fonts, colors, ...)\nSuch a collection of attributes is called a \"face\"." :group 'emacs)

(defcustom face-frob-from-locale-first nil "\
*If non nil, use kludgy way of frobbing fonts suitable for non-mule
multi-charset environments." :group 'faces :type 'boolean)

(defcustom frame-background-mode nil "\
*The brightness of the background.
Set this to the symbol dark if your background color is dark, light if
your background is light, or nil (default) if you want Emacs to
examine the brightness for you." :group 'faces :type '(choice (choice-item dark) (choice-item light) (choice-item :tag "Auto" nil)))

(defcustom init-face-from-resources t "\
If non nil, attempt to initialize faces from the resource database." :group 'faces :type 'boolean)

;;;***

;;;### (autoloads (list-directory-verbose-switches list-directory-brief-switches save-some-buffers-query-display-buffer change-major-mode-with-file-name find-file-not-true-dirname-list find-file-magic-files-alist enable-local-eval enable-local-variables find-file-run-dired save-abbrevs auto-save-visited-file-name auto-save-default require-final-newline kept-new-versions kept-old-versions delete-old-versions version-control file-precious-flag revert-without-query buffer-offer-save backup-by-copying-when-mismatch backup-by-copying-when-linked backup-by-copying make-backup-files directory-abbrev-alist find-file backup files) "files" "lisp/files.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/files.el")

(defgroup files nil "Support editing files." :group 'emacs)

(defgroup backup nil "Backups of edited data files." :group 'files)

(defgroup find-file nil "Finding and editing files." :group 'files)

(defcustom directory-abbrev-alist nil "\
*Alist of abbreviations for file directories.
A list of elements of the form (FROM . TO), each meaning to replace
FROM with TO when it appears in a directory name.
This replacement is done when setting up the default directory of a
newly visited file.  *Every* FROM string should start with \\\\` or ^.

Use this feature when you have directories which you normally refer to
via absolute symbolic links or to eliminate automounter mount points
from the beginning of your filenames.  Make TO the name of the link,
and FROM the name it is linked to." :type '(repeat (cons :format "%v" :value ("\\`" . "") (regexp :tag "From") (regexp :tag "To"))) :group 'find-file)

(defcustom make-backup-files t "\
*Non-nil means make a backup of a file the first time it is saved.
This can be done by renaming the file or by copying.

Renaming means that XEmacs renames the existing file so that it is a
backup file, then writes the buffer into a new file.  Any other names
that the old file had will now refer to the backup file.  The new file
is owned by you and its group is defaulted.

Copying means that XEmacs copies the existing file into the backup
file, then writes the buffer on top of the existing file.  Any other
names that the old file had will now refer to the new (edited) file.
The file's owner and group are unchanged.

The choice of renaming or copying is controlled by the variables
`backup-by-copying', `backup-by-copying-when-linked' and
`backup-by-copying-when-mismatch'.  See also `backup-inhibited'." :type 'boolean :group 'backup)

(defcustom backup-by-copying nil "\
*Non-nil means always use copying to create backup files.
See documentation of variable `make-backup-files'." :type 'boolean :group 'backup)

(defcustom backup-by-copying-when-linked nil "\
*Non-nil means use copying to create backups for files with multiple names.
This causes the alternate names to refer to the latest version as edited.
This variable is relevant only if `backup-by-copying' is nil." :type 'boolean :group 'backup)

(defcustom backup-by-copying-when-mismatch nil "\
*Non-nil means create backups by copying if this preserves owner or group.
Renaming may still be used (subject to control of other variables)
when it would not result in changing the owner or group of the file;
that is, for files which are owned by you and whose group matches
the default for a new file created there by you.
This variable is relevant only if `backup-by-copying' is nil." :type 'boolean :group 'backup)

(defcustom buffer-offer-save nil "\
*Non-nil in a buffer means offer to save the buffer on exit
even if the buffer is not visiting a file.
Automatically local in all buffers." :type 'boolean :group 'find-file)

(defcustom revert-without-query nil "\
*Specify which files should be reverted without query.
The value is a list of regular expressions.
If the file name matches one of these regular expressions,
then `revert-buffer' reverts the file without querying
if the file has changed on disk and you have not edited the buffer." :type '(repeat (regexp "")) :group 'find-file)

(defcustom file-precious-flag nil "\
*Non-nil means protect against I/O errors while saving files.
Some modes set this non-nil in particular buffers.

This feature works by writing the new contents into a temporary file
and then renaming the temporary file to replace the original.
In this way, any I/O error in writing leaves the original untouched,
and there is never any instant where the file is nonexistent.

Note that this feature forces backups to be made by copying.
Yet, at the same time, saving a precious file
breaks any hard links between it and other files." :type 'boolean :group 'backup)

(defcustom version-control nil "\
*Control use of version numbers for backup files.
t means make numeric backup versions unconditionally.
nil means make them for files that have some already.
`never' means do not make them." :type 'boolean :group 'backup :group 'vc)

(defcustom delete-old-versions (when noninteractive 'leave) "\
*If t, delete excess backup versions silently.
If nil, ask confirmation.  Any other value prevents any trimming." :type '(choice (const :tag "Delete" t) (const :tag "Ask" nil) (sexp :tag "Leave" :format "%t
" other)) :group 'backup)

(defcustom kept-old-versions 2 "\
*Number of oldest versions to keep when a new numbered backup is made." :type 'integer :group 'backup)

(defcustom kept-new-versions 2 "\
*Number of newest versions to keep when a new numbered backup is made.
Includes the new backup.  Must be > 0" :type 'integer :group 'backup)

(defcustom require-final-newline nil "\
*Value of t says silently ensure a file ends in a newline when it is saved.
Non-nil but not t says ask user whether to add a newline when there isn't one.
nil means don't add newlines." :type '(choice (const :tag "Off" nil) (const :tag "Add" t) (sexp :tag "Ask" :format "%t
" ask)) :group 'editing-basics)

(defcustom auto-save-default t "\
*Non-nil says by default do auto-saving of every file-visiting buffer." :type 'boolean :group 'auto-save)

(defcustom auto-save-visited-file-name nil "\
*Non-nil says auto-save a buffer in the file it is visiting, when practical.
Normally auto-save files are written under other names." :type 'boolean :group 'auto-save)

(defcustom save-abbrevs nil "\
*Non-nil means save word abbrevs too when files are saved.
Loading an abbrev file sets this to t." :type 'boolean :group 'abbrev)

(defcustom find-file-run-dired t "\
*Non-nil says run dired if `find-file' is given the name of a directory." :type 'boolean :group 'find-file)

(defcustom enable-local-variables t "\
*Control use of local-variables lists in files you visit.
The value can be t, nil or something else.
A value of t means local-variables lists are obeyed;
nil means they are ignored; anything else means query.

The command \\[normal-mode] always obeys local-variables lists
and ignores this variable." :type '(choice (const :tag "Obey" t) (const :tag "Ignore" nil) (sexp :tag "Query" :format "%t
" other)) :group 'find-file)

(defcustom enable-local-eval 'maybe "\
*Control processing of the \"variable\" `eval' in a file's local variables.
The value can be t, nil or something else.
A value of t means obey `eval' variables;
nil means ignore them; anything else means query.

The command \\[normal-mode] always obeys local-variables lists
and ignores this variable." :type '(choice (const :tag "Obey" t) (const :tag "Ignore" nil) (sexp :tag "Query" :format "%t
" other)) :group 'find-file)

(defcustom find-file-magic-files-alist '((file-directory-p . find-file-try-dired-noselect)) "\
Alist where each element is in form (PREDICATE . FUNCTION-OF-ONE-ARGUMENT).
FUNCTION-OF-ONE-ARGUMENT must return some buffer." :type 'alist :group 'find-file)

(defcustom find-file-not-true-dirname-list nil "\
*List of logical names for which visiting shouldn't save the true dirname." :type '(repeat (string :tag "Name")) :group 'find-file)

(defcustom change-major-mode-with-file-name t "\
*Non-nil means \\[write-file] should set the major mode from the file name.
However, the mode will not be changed if
\(1) a local variables list or the `-*-' line specifies a major mode, or
\(2) the current major mode is a \"special\" mode,
    not suitable for ordinary files, or
\(3) the new file name does not particularly specify any mode." :type 'boolean :group 'editing-basics)

(defcustom save-some-buffers-query-display-buffer t "\
*Non-nil makes `\\[save-some-buffers]' switch to the buffer offered for saving." :type 'boolean :group 'editing-basics)

(defcustom list-directory-brief-switches "-CF" "\
*Switches for list-directory to pass to `ls' for brief listing." :type 'string :group 'dired)

(defcustom list-directory-verbose-switches "-l" "\
*Switches for list-directory to pass to `ls' for verbose listing," :type 'string :group 'dired)

;;;***

;;;### (autoloads (adaptive-fill-function adaptive-fill-regexp adaptive-fill-mode colon-double-space sentence-end-double-space fill-individual-varying-indent fill) "fill" "lisp/fill.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/fill.el")

(defgroup fill nil "Indenting and filling text." :group 'editing)

(defcustom fill-individual-varying-indent nil "\
*Controls criterion for a new paragraph in `fill-individual-paragraphs'.
Non-nil means changing indent doesn't end a paragraph.
That mode can handle paragraphs with extra indentation on the first line,
but it requires separator lines between paragraphs.
A value of nil means that any change in indentation starts a new paragraph." :type 'boolean :group 'fill)

(defcustom sentence-end-double-space t "\
*Non-nil means a single space does not end a sentence.
This variable applies only to filling, not motion commands.  To
change the behavior of motion commands, see `sentence-end'." :type 'boolean :group 'fill)

(defcustom colon-double-space nil "\
*Non-nil means put two spaces after a colon when filling." :type 'boolean :group 'fill)

(defcustom adaptive-fill-mode t "\
*Non-nil means determine a paragraph's fill prefix from its text." :type 'boolean :group 'fill)

(defcustom adaptive-fill-regexp "[ 	]*\\([#;>*]+ +\\)?" "\
*Regexp to match text at start of line that constitutes indentation.
If Adaptive Fill mode is enabled, whatever text matches this pattern
on the second line of a paragraph is used as the standard indentation
for the paragraph.  If the paragraph has just one line, the indentation
is taken from that line." :type 'regexp :group 'fill)

(defcustom adaptive-fill-function nil "\
*Function to call to choose a fill prefix for a paragraph.
This function is used when `adaptive-fill-regexp' does not match." :type 'function :group 'fill)

;;;***

;;;### (autoloads (font-lock-mode font-lock-fontify-string-delimiters font-lock-maximum-size font-lock-maximum-decoration font-lock-use-fonts font-lock-use-colors font-lock-mode-disable-list font-lock-mode-enable-list font-lock-auto-fontify font-lock-message-threshold font-lock-verbose font-lock-faces font-lock) "font-lock" "lisp/font-lock.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/font-lock.el")

(defgroup font-lock nil "Decorate source files with fonts/colors based on syntax.\nFont-lock-mode is a minor mode that causes your comments to be\ndisplayed in one face, strings in another, reserved words in another,\ndocumentation strings in another, and so on.\n\nComments will be displayed in `font-lock-comment-face'.\nStrings will be displayed in `font-lock-string-face'.\nDoc strings will be displayed in `font-lock-doc-string-face'.\nFunction and variable names (in their defining forms) will be displayed\n in `font-lock-function-name-face'.\nReserved words will be displayed in `font-lock-keyword-face'.\nPreprocessor conditionals will be displayed in `font-lock-preprocessor-face'." :group 'languages)

(defgroup font-lock-faces nil "Faces used by the font-lock package." :group 'font-lock :group 'faces)

(defcustom font-lock-verbose t "\
*If non-nil, means show status messages when fontifying.
See also `font-lock-message-threshold'." :type 'boolean :group 'font-lock)

(defcustom font-lock-message-threshold 6000 "\
*Minimum size of region being fontified for status messages to appear.

The size is measured in characters.  This affects `font-lock-fontify-region'
but not `font-lock-fontify-buffer'. (In other words, when you first visit
a file and it gets fontified, you will see status messages no matter what
size the file is.  However, if you do something else like paste a
chunk of text, you will see status messages only if the changed region is
large enough.)

Note that setting `font-lock-verbose' to nil disables the status
messages entirely." :type 'integer :group 'font-lock)

(defcustom font-lock-auto-fontify t "\
*Whether font-lock should automatically fontify files as they're loaded.
This will only happen if font-lock has fontifying keywords for the major
mode of the file.  You can get finer-grained control over auto-fontification
by using this variable in combination with `font-lock-mode-enable-list' or
`font-lock-mode-disable-list'." :type 'boolean :group 'font-lock)

(defcustom font-lock-mode-enable-list nil "\
*List of modes to auto-fontify, if `font-lock-auto-fontify' is nil." :type '(repeat (symbol :tag "Mode")) :group 'font-lock)

(defcustom font-lock-mode-disable-list nil "\
*List of modes not to auto-fontify, if `font-lock-auto-fontify' is t." :type '(repeat (symbol :tag "Mode")) :group 'font-lock)

(defcustom font-lock-use-colors '(color) "\
*Specification for when Font Lock will set up color defaults.
Normally this should be '(color), meaning that Font Lock will set up
color defaults that are only used on color displays.  Set this to nil
if you don't want Font Lock to set up color defaults at all.  This
should be one of

-- a list of valid tags, meaning that the color defaults will be used
   when all of the tags apply. (e.g. '(color x))
-- a list whose first element is 'or and whose remaining elements are
   lists of valid tags, meaning that the defaults will be used when
   any of the tag lists apply.
-- nil, meaning that the defaults should not be set up at all.

\(If you specify face values in your init file, they will override any
that Font Lock specifies, regardless of whether you specify the face
values before or after loading Font Lock.)

See also `font-lock-use-fonts'.  If you want more control over the faces
used for fontification, see the documentation of `font-lock-mode' for
how to do it." :type 'sexp :group 'font-lock)

(defcustom font-lock-use-fonts '(or (mono) (grayscale)) "\
*Specification for when Font Lock will set up non-color defaults.

Normally this should be '(or (mono) (grayscale)), meaning that Font
Lock will set up non-color defaults that are only used on either mono
or grayscale displays.  Set this to nil if you don't want Font Lock to
set up non-color defaults at all.  This should be one of

-- a list of valid tags, meaning that the non-color defaults will be used
   when all of the tags apply. (e.g. '(grayscale x))
-- a list whose first element is 'or and whose remaining elements are
   lists of valid tags, meaning that the defaults will be used when
   any of the tag lists apply.
-- nil, meaning that the defaults should not be set up at all.

\(If you specify face values in your init file, they will override any
that Font Lock specifies, regardless of whether you specify the face
values before or after loading Font Lock.)

See also `font-lock-use-colors'.  If you want more control over the faces
used for fontification, see the documentation of `font-lock-mode' for
how to do it." :type 'sexp :group 'font-lock)

(defcustom font-lock-maximum-decoration t "\
*If non-nil, the maximum decoration level for fontifying.
If nil, use the minimum decoration (equivalent to level 0).
If t, use the maximum decoration available.
If a number, use that level of decoration (or if not available the maximum).
If a list, each element should be a cons pair of the form (MAJOR-MODE . LEVEL),
where MAJOR-MODE is a symbol or t (meaning the default).  For example:
 ((c++-mode . 2) (c-mode . t) (t . 1))
means use level 2 decoration for buffers in `c++-mode', the maximum decoration
available for buffers in `c-mode', and level 1 decoration otherwise." :type '(choice (const :tag "default" nil) (const :tag "maximum" t) (integer :tag "level" 1) (repeat :menu-tag "mode specific" :tag "mode specific" :value ((t . t)) (cons :tag "Instance" (radio :tag "Mode" (const :tag "all" t) (symbol :tag "name")) (radio :tag "Decoration" (const :tag "default" nil) (const :tag "maximum" t) (integer :tag "level" 1))))) :group 'font-lock)

(defcustom font-lock-maximum-size (* 250 1024) "\
*If non-nil, the maximum size for buffers for fontifying.
Only buffers less than this can be fontified when Font Lock mode is turned on.
If nil, means size is irrelevant.
If a list, each element should be a cons pair of the form (MAJOR-MODE . SIZE),
where MAJOR-MODE is a symbol or t (meaning the default).  For example:
 ((c++-mode . 256000) (c-mode . 256000) (rmail-mode . 1048576))
means that the maximum size is 250K for buffers in `c++-mode' or `c-mode', one
megabyte for buffers in `rmail-mode', and size is irrelevant otherwise." :type '(choice (const :tag "none" nil) (integer :tag "size") (repeat :menu-tag "mode specific" :tag "mode specific" :value ((t)) (cons :tag "Instance" (radio :tag "Mode" (const :tag "all" t) (symbol :tag "name")) (radio :tag "Size" (const :tag "none" nil) (integer :tag "size"))))) :group 'font-lock)

(defcustom font-lock-fontify-string-delimiters nil "\
*If non-nil, apply font-lock-string-face to string delimiters as well as
string text when fontifying." :type 'boolean :group 'font-lock)

(defcustom font-lock-mode nil "\
Non nil means `font-lock-mode' is on" :group 'font-lock :type 'boolean :initialize 'custom-initialize-default :require 'font-lock :set (function (lambda (var val) (font-lock-mode (or val 0)))))

;;;***

;;;### (autoloads (font-menu-submenu-name-format font-menu-max-items font-menu-this-frame-only-p font-menu-ignore-scaled-fonts) "font-menu" "lisp/font-menu.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/font-menu.el")

(defcustom font-menu-ignore-scaled-fonts nil "\
*If non-nil, then the font menu will try to show only bitmap fonts." :type 'boolean :group 'font-menu)

(defcustom font-menu-this-frame-only-p nil "\
*If non-nil, then changing the default font from the font menu will only
affect one frame instead of all frames." :type 'boolean :group 'font-menu)

(defcustom font-menu-max-items 25 "\
*Maximum number of items in the font menu
If number of entries in a menu is larger than this value, split menu
into submenus of nearly equal length.  If nil, never split menu into
submenus." :group 'font-menu :type '(choice (const :tag "no submenus" nil) (integer)))

(defcustom font-menu-submenu-name-format "%-12.12s ... %.12s" "\
*Format specification of the submenu name.
Used by `font-menu-split-long-menu' if the number of entries in a menu is
larger than `font-menu-menu-max-items'.
This string should contain one %s for the name of the first entry and
one %s for the name of the last entry in the submenu.
If the value is a function, it should return the submenu name.  The
function is be called with two arguments, the names of the first and
the last entry in the menu." :group 'font-menu :type '(choice (string :tag "Format string") (function)))

;;;***

;;;### (autoloads (font-blink-interval) "font" "lisp/font.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/font.el")

(defcustom font-blink-interval 0.5 "\
How often to blink faces" :type 'number :group 'faces)

;;;***

;;;### (autoloads (temp-buffer-max-height temp-buffer-shrink-to-fit get-frame-for-buffer-default-to-current get-frame-for-buffer-default-instance-limit get-frame-for-buffer-default-frame-name auto-lower-frame auto-raise-frame special-display-frame-plist pop-up-frame-plist minibuffer-frame-plist initial-frame-plist frames) "frame" "lisp/frame.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/frame.el")

(defgroup frames nil "Support for Emacs frames and window systems." :group 'environment)

(defcustom initial-frame-plist '(minibuffer t) "\
Plist of frame properties for creating the initial X window frame.
You can set this in your `.emacs' file; for example,
  (setq initial-frame-plist '(top 1 left 1 width 80 height 55))
Properties specified here supersede the values given in `default-frame-plist'.
The format of this can also be an alist for backward compatibility.

If the value calls for a frame without a minibuffer, and you have not created
a minibuffer frame on your own, one is created according to
`minibuffer-frame-plist'.

You can specify geometry-related options for just the initial frame
by setting this variable in your `.emacs' file; however, they won't
take effect until Emacs reads `.emacs', which happens after first creating
the frame.  If you want the frame to have the proper geometry as soon
as it appears, you need to use this three-step process:
* Specify X resources to give the geometry you want.
* Set `default-frame-plist' to override these options so that they
  don't affect subsequent frames.
* Set `initial-frame-plist' in a way that matches the X resources,
  to override what you put in `default-frame-plist'." :type 'plist :group 'frames)

(defcustom minibuffer-frame-plist '(width 80 height 2 menubar-visible-p nil default-toolbar-visible-p nil) "\
Plist of frame properties for initially creating a minibuffer frame.
You can set this in your `.emacs' file; for example,
  (setq minibuffer-frame-plist '(top 1 left 1 width 80 height 2))
Properties specified here supersede the values given in
`default-frame-plist'.
The format of this can also be an alist for backward compatibility." :type 'plist :group 'frames)

(defcustom pop-up-frame-plist nil "\
Plist of frame properties used when creating pop-up frames.
Pop-up frames are used for completions, help, and the like.
This variable can be set in your init file, like this:
  (setq pop-up-frame-plist '(width 80 height 20))
These supersede the values given in `default-frame-plist'.
The format of this can also be an alist for backward compatibility." :type 'plist :group 'frames)

(defcustom special-display-frame-plist '(height 14 width 80 unsplittable t) "\
*Plist of frame properties used when creating special frames.
Special frames are used for buffers whose names are in
`special-display-buffer-names' and for buffers whose names match
one of the regular expressions in `special-display-regexps'.
This variable can be set in your init file, like this:
  (setq special-display-frame-plist '(width 80 height 20))
These supersede the values given in `default-frame-plist'.
The format of this can also be an alist for backward compatibility." :type 'plist :group 'frames)

(defcustom auto-raise-frame nil "\
*If true, frames will be raised to the top when selected.
Under X, most ICCCM-compliant window managers will have an option to do this
for you, but this variable is provided in case you're using a broken WM." :type 'boolean :group 'frames)

(defcustom auto-lower-frame nil "\
*If true, frames will be lowered to the bottom when no longer selected.
Under X, most ICCCM-compliant window managers will have an option to do this
for you, but this variable is provided in case you're using a broken WM." :type 'boolean :group 'frames)

(defcustom get-frame-for-buffer-default-frame-name nil "\
*The default frame to select; see doc of `get-frame-for-buffer'." :type 'string :group 'frames)

(defcustom get-frame-for-buffer-default-instance-limit nil "\
*The default instance limit for creating new frames;
see doc of `get-frame-for-buffer'." :type 'integer :group 'frames)

(defcustom get-frame-for-buffer-default-to-current nil "\
*When non-nil, `get-frame-for-buffer' will default to the selected frame." :type 'boolean :group 'frames)

(defcustom temp-buffer-shrink-to-fit nil "\
*When non-nil resize temporary output buffers to minimize blank lines." :type 'boolean :group 'frames)

(defcustom temp-buffer-max-height 0.5 "\
*Proportion of frame to use for temp windows." :type 'number :group 'frames)

;;;***

;;;### (autoloads (gnuserv-make-temp-file-backup gnuserv-temp-file-regexp gnuserv-kill-quietly gnuserv-shutdown-hook gnuserv-init-hook gnuserv-done-hook gnuserv-visit-hook gnuserv-program gnuserv-view-file-function gnuserv-find-file-function gnuserv-done-temp-file-function gnuserv-done-function gnuserv-frame-plist gnuserv-frame gnuserv-mode-line-string gnuserv) "gnuserv" "lisp/gnuserv.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/gnuserv.el")

(defgroup gnuserv nil "The gnuserv suite of programs to talk to Emacs from outside." :group 'environment :group 'processes :group 'terminals)

(defcustom gnuserv-mode-line-string " Server" "\
*String to display in the modeline when Gnuserv is active.
Set this to nil if you don't want a modeline indicator." :type '(choice string (const :tag "none" nil)) :group 'gnuserv)

(defcustom gnuserv-frame nil "\
*The frame to be used to display all edited files.
If nil, then a new frame is created for each file edited.
If t, then the currently selected frame will be used.
If a function, then this will be called with a symbol `x' or `tty' as the
only argument, and its return value will be interpreted as above." :tag "Gnuserv Frame" :type '(radio (const :tag "Create new frame each time" nil) (const :tag "Use selected frame" t) (function-item :tag "Use main Emacs frame" gnuserv-main-frame-function) (function-item :tag "Use visible frame, otherwise create new" gnuserv-visible-frame-function) (function-item :tag "Create special Gnuserv frame and use it" gnuserv-special-frame-function) (function :tag "Other")) :group 'gnuserv :group 'frames)

(defcustom gnuserv-frame-plist nil "\
*Plist of frame properties for creating a gnuserv frame." :type 'plist :group 'gnuserv :group 'frames)

(defcustom gnuserv-done-function 'kill-buffer "\
*Function used to remove a buffer after editing.
It is called with one BUFFER argument.  Functions such as `kill-buffer' and
`bury-buffer' are good values. See also `gnuserv-done-temp-file-function'." :type '(radio (function-item kill-buffer) (function-item bury-buffer) (function :tag "Other")) :group 'gnuserv)

(defcustom gnuserv-done-temp-file-function 'kill-buffer "\
*Function used to remove a temporary buffer after editing.
It is called with one BUFFER argument.  Functions such as `kill-buffer' and
`bury-buffer' are good values. See also `gnuserv-done-temp-file-function'." :type '(radio (function-item kill-buffer) (function-item bury-buffer) (function :tag "Other")) :group 'gnuserv)

(defcustom gnuserv-find-file-function 'find-file "\
*Function to visit a file with.
It takes one argument, a file name to visit." :type 'function :group 'gnuserv)

(defcustom gnuserv-view-file-function 'view-file "\
*Function to view a file with.
It takes one argument, a file name to view." :type '(radio (function-item view-file) (function-item find-file-read-only) (function :tag "Other")) :group 'gnuserv)

(defcustom gnuserv-program "gnuserv" "\
*Program to use as the editing server." :type 'string :group 'gnuserv)

(defcustom gnuserv-visit-hook nil "\
*Hook run after visiting a file." :type 'hook :group 'gnuserv)

(defcustom gnuserv-done-hook nil "\
*Hook run when done editing a buffer for the Emacs server.
The hook functions are called after the file has been visited, with the
current buffer set to the visiting buffer." :type 'hook :group 'gnuserv)

(defcustom gnuserv-init-hook nil "\
*Hook run after the server is started." :type 'hook :group 'gnuserv)

(defcustom gnuserv-shutdown-hook nil "\
*Hook run before the server exits." :type 'hook :group 'gnuserv)

(defcustom gnuserv-kill-quietly nil "\
*Non-nil means to kill buffers with clients attached without requiring confirmation." :type 'boolean :group 'gnuserv)

(defcustom gnuserv-temp-file-regexp (concat "^" (temp-directory) "/Re\\|/draft$") "\
*Regexp which should match filenames of temporary files deleted
and reused by the programs that invoke the Emacs server." :type 'regexp :group 'gnuserv)

(defcustom gnuserv-make-temp-file-backup nil "\
*Non-nil makes the server backup temporary files also." :type 'boolean :group 'gnuserv)

;;;***

;;;### (autoloads (dialog-frame-plist) "gui" "lisp/gui.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/gui.el")

(defcustom dialog-frame-plist '(width 60 height 20) "\
Plist of frame properties for initially creating a dialog frame.
Properties specified here supersede the values given in
`default-frame-plist'." :type 'plist :group 'frames)

;;;***

;;;### (autoloads (progress-feedback-style progress-feedback-use-echo-area buffers-tab-max-buffer-line-length buffers-tab-format-buffer-line-function buffers-tab-grouping-regexp buffers-tab-face buffers-tab-sort-function buffers-tab-filter-functions buffers-tab-selection-function buffers-tab-omit-function buffers-tab-switch-to-buffer-function buffers-tab-max-size gutter-buffers-tab-enabled gutter-buffers-tab-visible-p buffers-tab) "gutter-items" "lisp/gutter-items.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/gutter-items.el")

(defgroup buffers-tab nil "Customization of `Buffers' tab." :group 'gutter)

(defcustom gutter-buffers-tab-visible-p (gutter-element-visible-p default-gutter-visible-p 'buffers-tab) "\
Whether the buffers tab is globally visible.

There are side-effects, so don't setq it; use Customize or the options menu." :group 'buffers-tab :type 'boolean :set (function (lambda (var val) (set-gutter-element-visible-p default-gutter-visible-p 'buffers-tab val) (setq gutter-buffers-tab-visible-p val))))

(defcustom gutter-buffers-tab-enabled t "\
*Whether to enable support for buffers tab in the gutter.
This is different to `gutter-buffers-tab-visible-p' which still runs hooks
even when the gutter is invisible." :group 'buffers-tab :type 'boolean)

(defcustom buffers-tab-max-size 6 "\
*Maximum number of entries which may appear on the \"Buffers\" tab.
If this is 10, then only the ten most-recently-selected buffers will be
shown.  If this is nil, then all buffers will be shown.  Setting this to
a large number or nil will slow down tab responsiveness." :type '(choice (const :tag "Show all" nil) (integer 6)) :group 'buffers-tab)

(defcustom buffers-tab-switch-to-buffer-function 'buffers-tab-switch-to-buffer "\
*The function to call to select a buffer from the buffers tab.
`switch-to-buffer' is a good choice, as is `pop-to-buffer'." :type '(radio (function-item switch-to-buffer) (function-item pop-to-buffer) (function :tag "Other")) :group 'buffers-tab)

(defcustom buffers-tab-omit-function 'buffers-menu-omit-invisible-buffers "\
*A function specifying the buffers to omit from the buffers tab, or nil.
This is passed a buffer and should return non-nil if the buffer should be
omitted.  The default value `buffers-menu-omit-invisible-buffers' omits
buffers that are normally considered \"invisible\" (those whose name
begins with a space)." :type '(choice (const :tag "None" nil) function) :group 'buffers-tab)

(defcustom buffers-tab-selection-function nil "\
*A function specifying buffers to display in the buffers tab, or nil.
Don't use this---it is never consulted.  Use `buffers-tab-filter-functions'
instead.

The function must take arguments (BUF1 BUF2).  BUF1 is a candidate for
display in the buffers tab control.  BUF2 is current (first in the buffers
list).  Return non-nil if BUF1 should be added to the tab control." :type '(choice function (const :tag "None" nil)) :group 'buffers-tab)

(defcustom buffers-tab-filter-functions '(select-buffers-tab-buffers-by-mode) "\
*A list of functions specifying buffers to display in the buffers tab.

If nil, all buffers are kept, up to `buffers-tab-max-size', in usual order.
Otherwise, each function in the list must take arguments (BUF1 BUF2).
BUF1 is the candidate, and BUF2 is the current buffer (first in the buffers
list).  The function should return non-nil if BUF1 should be added to the
buffers tab.  BUF1 will be omitted if any of the functions returns nil.

Defaults to `select-buffers-tab-buffers-by-mode', which adds BUF1 if BUF1 and
BUF2 have the same major mode, or both match `buffers-tab-grouping-regexp'." :type '(repeat function) :group 'buffers-tab)

(defcustom buffers-tab-sort-function nil "\
*If non-nil, a function specifying the buffers to select from the
buffers tab.  This is passed the buffer list and returns the list in the
order desired for the tab widget.  The default value `nil' leaves the
list in `buffer-list' order (usual most-recently-selected-first)." :type '(choice (const :tag "None" nil) function) :group 'buffers-tab)

(defcustom buffers-tab-face 'buffers-tab "\
*Face to use for displaying the buffers tab." :type 'face :group 'buffers-tab)

(defcustom buffers-tab-grouping-regexp '("^\\(gnus-\\|message-mode\\|mime/viewer-mode\\)" "^\\(emacs-lisp-\\|lisp-\\)") "\
*If non-nil, a list of regular expressions for buffer grouping.
Each regular expression is applied to the current major-mode symbol
name and mode-name, if it matches then any other buffers that match
the same regular expression be added to the current group." :type '(choice (const :tag "None" nil) sexp) :group 'buffers-tab)

(defcustom buffers-tab-format-buffer-line-function 'format-buffers-tab-line "\
*The function to call to return a string to represent a buffer in the
buffers tab.  The function is passed a buffer and should return a
string.  The default value `format-buffers-tab-line' just returns the
name of the buffer, optionally truncated to
`buffers-tab-max-buffer-line-length'.  Also check out
`slow-format-buffers-menu-line' which returns a whole bunch of info
about a buffer." :type 'function :group 'buffers-tab)

(defcustom buffers-tab-max-buffer-line-length (specifier-instance buffers-tab-default-buffer-line-length) "\
*Maximum length of text which may appear in a \"Buffers\" tab.
Buffer names over this length will be truncated with elipses.
If this is 0, then the full buffer name will be shown." :type '(choice (const :tag "Show all" 0) (integer 25)) :group 'buffers-tab :set (function (lambda (var val) (set-specifier buffers-tab-default-buffer-line-length val) (setq buffers-tab-max-buffer-line-length val))))

(defcustom progress-feedback-use-echo-area t "\
*Whether progress gauge display should display in the echo area.
If NIL then progress gauges will be displayed with whatever native widgets
are available on the current console. If non-NIL then progress display will be
textual and displayed in the echo area." :type 'boolean :group 'gutter)

(defcustom progress-feedback-style 'large "\
*Control the appearance of the progress gauge.
If 'large, the default, then the progress-feedback text is displayed
above the gauge itself. If 'small then the gauge and text are arranged
side-by-side." :group 'gutter :type '(choice (const :tag "large" large) (const :tag "small" small)))

;;;***

;;;### (autoloads (default-gutter-position gutter) "gutter" "lisp/gutter.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/gutter.el")

(defgroup gutter nil "Input from the gutters." :group 'environment)

(defcustom default-gutter-position (default-gutter-position) "\
The location of the default gutter. It can be 'top, 'bottom, 'left or
'right. This option should be customized through the options menu.
To set the gutter position explicitly use `set-default-gutter-position'" :group 'gutter :type '(choice (const :tag "top" top) (const :tag "bottom" bottom) (const :tag "left" left) (const :tag "right" right)) :set (function (lambda (var val) (set-default-gutter-position val) (setq default-gutter-position val))))

;;;***

;;;### (autoloads (three-step-help) "help-macro" "lisp/help-macro.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/help-macro.el")

(defcustom three-step-help t "\
*Non-nil means give more info about Help command in three steps.
The three steps are simple prompt, prompt with all options,
and window listing and describing the options.
A value of nil means skip the middle step, so that
\\[help-command] \\[help-command] gives the window that lists the options." :type 'boolean :group 'help-appearance)

;;;***

;;;### (autoloads (describe-function-show-arglist view-lossage-message-count view-lossage-key-count mode-for-help help-max-help-buffers help-selects-help-window help-appearance help) "help" "lisp/help.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/help.el")

(defgroup help nil "Support for on-line help systems." :group 'emacs)

(defgroup help-appearance nil "Appearance of help buffers." :group 'help)

(defcustom help-selects-help-window t "\
*If nil, use the \"old Emacs\" behavior for Help buffers.
This just displays the buffer in another window, rather than selecting
the window." :type 'boolean :group 'help-appearance)

(defcustom help-max-help-buffers 10 "\
*Maximum help buffers to allow before they start getting killed.
If this is a positive integer, before a help buffer is displayed
by `with-displaying-help-buffer', any excess help buffers which
are not being displayed are first killed.  Otherwise, if it is
zero or nil, only one help buffer, \"*Help*\" is ever used." :type '(choice integer (const :tag "None" nil)) :group 'help-appearance)

(defcustom mode-for-help 'help-mode "\
*Mode that help buffers are put into.")

(defcustom view-lossage-key-count 100 "\
*Number of keys `view-lossage' shows.
The maximum number of available keys is governed by `recent-keys-ring-size'." :type 'integer :group 'help)

(defcustom view-lossage-message-count 100 "\
*Number of minibuffer messages `view-lossage' shows." :type 'integer :group 'help)

(defcustom describe-function-show-arglist t "\
*If non-nil, describe-function will show the function's arglist." :type 'boolean :group 'help-appearance)

;;;***

;;;### (autoloads (hyper-apropos-faces hyper-apropos-prettyprint-long-values hyper-apropos-shrink-window hyper-apropos-programming-apropos hyper-apropos-show-brief-docs hyper-apropos) "hyper-apropos" "lisp/hyper-apropos.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/hyper-apropos.el")

(defgroup hyper-apropos nil "Hypertext emacs lisp documentation interface." :group 'docs :group 'lisp :group 'tools :group 'help :group 'matching)

(defcustom hyper-apropos-show-brief-docs t "\
*If non-nil, display some documentation in the \"*Hyper Apropos*\" buffer.
Setting this to nil will speed up searches." :type 'boolean :group 'hyper-apropos)

(defcustom hyper-apropos-programming-apropos t "\
*If non-nil, list all the functions and variables.
This will cause more output to be generated, and take a longer time.

Otherwise, only the interactive functions and user variables will be listed." :type 'boolean :group 'hyper-apropos)

(defcustom hyper-apropos-shrink-window nil "\
*If non-nil, shrink *Hyper Help* buffer if possible." :type 'boolean :group 'hyper-apropos)

(defcustom hyper-apropos-prettyprint-long-values t "\
*If non-nil, then try to beautify the printing of very long values." :type 'boolean :group 'hyper-apropos)

(defgroup hyper-apropos-faces nil "Faces defined by hyper-apropos." :prefix "hyper-apropos-" :group 'faces)

;;;***

;;;### (autoloads (Info-no-description-string Info-button1-follows-hyperlink Info-annotations-path Info-footnote-tag Info-suffix-list Info-save-auto-generated-dir Info-auto-generate-directory Info-additional-search-directory-list Info-fontify Info-auto-advance Info-restoring-point Info-enable-active-nodes Info-enable-edit Info-novice Info-inhibit-toolbar info-faces info) "info" "lisp/info.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/info.el")

(defgroup info nil "The info package for Emacs." :group 'help :group 'docs)

(defgroup info-faces nil "The faces used by info browser." :group 'info :group 'faces)

(defcustom Info-inhibit-toolbar nil "\
*Non-nil means don't use the specialized Info toolbar." :type 'boolean :group 'info)

(defcustom Info-novice nil "\
*Non-nil means to ask for confirmation before switching Info files." :type 'boolean :group 'info)

(defcustom Info-enable-edit nil "\
*Non-nil means the \\<Info-mode-map>\\[Info-edit] command in Info
can edit the current node.
This is convenient if you want to write info files by hand.
However, we recommend that you not do this.
It is better to write a Texinfo file and generate the Info file from that,
because that gives you a printed manual as well." :type 'boolean :group 'info)

(defcustom Info-enable-active-nodes t "\
*Non-nil allows Info to execute Lisp code associated with nodes.
The Lisp code is executed when the node is selected." :type 'boolean :group 'info)

(defcustom Info-restoring-point t "\
*Non-nil means to restore the cursor position when re-entering a node." :type 'boolean :group 'info)

(defcustom Info-auto-advance 'twice "\
*Control what SPC and DEL do when they can't scroll any further.
If nil, they beep and remain in the current node.
If t, they move to the next node (like Info-global-next/prev).
If anything else, they must be pressed twice to move to the next node." :type '(choice (const :tag "off" nil) (const :tag "advance" t) (const :tag "confirm" twice)) :group 'info)

(defcustom Info-fontify t "\
*Non-nil enables font features in XEmacs.
This variable is ignored unless running under XEmacs." :type 'boolean :group 'info)

(defcustom Info-additional-search-directory-list nil "\
*List of additional directories to search for Info documentation
files.  These directories are not searched for merging the `dir'
file. An example might be something like:
\"/usr/local/lib/xemacs/packages/lisp/calc/\"" :type '(repeat directory) :group 'info)

(defcustom Info-auto-generate-directory 'if-outdated "\
*When to auto generate an info directory listing.
Possible values are:
nil or `never' never auto-generate a directory listing,
  use any existing `dir' or `localdir' file and ignore info
  directories containing none
`always' auto-generate a directory listing ignoring existing
  `dir' and `localdir' files
`if-missing', the default, auto-generates a directory listing
  if no `dir' or `localdir' file is present.  Otherwise the
  contents of any of these files is used instead.
`if-outdated' auto-generates a directory listing if the `dir'
  and `localdir' are either inexistent or outdated (touched
  less recently than an info file in the same directory)." :type '(choice (const :tag "never" never) (const :tag "always" always) (const :tag "if-missing" if-missing) (const :tag "if-outdated" if-outdated)) :group 'info)

(defcustom Info-save-auto-generated-dir 'never "\
*Whether an auto-generated info directory listing should be saved.
Possible values are:
nil or `never', the default, auto-generated info directory
  information will never be saved.
`always', auto-generated info directory information will be saved to
  a `dir' file in the same directory overwriting it if it exists
`conservative', auto-generated info directory information will be saved
  to a `dir' file in the same directory but the user is asked before
  overwriting any existing file." :type '(choice (const :tag "never" never) (const :tag "always" always) (const :tag "conservative" conservative)) :group 'info)

(defcustom Info-suffix-list '(("") (".info") (".gz" . "gzip -dc %s") (".info.gz" . "gzip -dc %s") (".z" . "gzip -dc %s") (".info.z" . "gzip -dc %s") (".bz2" . "bzip2 -dc %s") (".info.bz2" . "bzip2 -dc %s") (".Z" . "uncompress -c %s") (".info.Z" . "uncompress -c %s") (".zip" . "unzip -c %s") (".info.zip" . "unzip -c %s") (".y" . "cat %s | unyabba") ("info.y" . "cat %s | unyabba") (".inf") (".igz" . "gzip -dc %s") (".inz" . "gzip -c %s")) "\
*List of file name suffixes and associated decoding commands.
Each entry should be (SUFFIX . STRING); if STRING contains %s, that is
changed to name of the file to decode, otherwise the file is given to
the command as standard input.  If STRING is nil, no decoding is done." :type '(repeat (cons (string :tag "suffix") (choice :tag "command" (const :tag "none" :value nil) (string :tag "")))) :group 'info)

(defcustom Info-footnote-tag "Note" "\
*Symbol that identifies a footnote or cross-reference.
All \"*Note\" references will be changed to use this word instead." :type 'string :group 'info)

(defcustom Info-annotations-path (list (paths-construct-path (list user-init-directory "info.notes")) (paths-construct-path '("~" ".infonotes")) (paths-construct-path '("usr" "lib" "info.notes") (char-to-string directory-sep-char))) "\
*Names of files that contain annotations for different Info nodes.
By convention, the first one should reside in your personal directory.
The last should be a world-writable \"public\" annotations file." :type '(repeat file) :group 'info)

(defcustom Info-button1-follows-hyperlink nil "\
*Non-nil means mouse button1 click will follow hyperlink." :type 'boolean :group 'info)

(defcustom Info-no-description-string "[No description available]" "\
*Description string for info files that have none" :type 'string :group 'info)

;;;***

;;;### (autoloads (isearch-highlight-all-matches search-ring-update regexp-search-ring-max search-ring-max isearch-hide-immediately search-invisible search-highlight search-whitespace-regexp search-nonincremental-instead search-slow-speed search-slow-window-lines search-exit-option isearch) "isearch-mode" "lisp/isearch-mode.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/isearch-mode.el")

(defgroup isearch nil "Incremental search minor mode." :prefix "search-" :group 'matching)

(defcustom search-exit-option t "\
*Non-nil means random control characters terminate incremental search." :type 'boolean :group 'isearch)

(defcustom search-slow-window-lines 1 "\
*Number of lines in slow search display windows.
These are the short windows used during incremental search on slow terminals.
Negative means put the slow search window at the top (normally it's at bottom)
and the value is minus the number of lines." :type 'integer :group 'isearch)

(defcustom search-slow-speed 1200 "\
*Highest terminal speed at which to use \"slow\" style incremental search.
This is the style where a one-line window is created to show the line
that the search has reached." :type 'integer :group 'isearch)

(defcustom search-nonincremental-instead t "\
*If non-nil, do a nonincremental search instead if exiting immediately.
Actually, `isearch-edit-string' is called to let you enter the search
string, and RET terminates editing and does a nonincremental search." :type 'boolean :group 'isearch)

(defcustom search-whitespace-regexp "\\(\\s-\\|[\n
]\\)+" "\
*If non-nil, regular expression to match a sequence of whitespace chars." :type 'regexp :group 'isearch)

(defcustom search-highlight t "\
*Whether incremental search and query-replace should highlight
the text that currently matches the search string." :type 'boolean :group 'isearch)

(defcustom search-invisible 'open "\
If t incremental search can match hidden text.
nil means don't match invisible text.
If the value is `open', if the text matched is made invisible by
an overlay having an `invisible' property and that overlay has a property
`isearch-open-invisible', then incremental search will show the contents.
\(This applies when using `outline.el' and `hideshow.el'.)" :type '(choice (const :tag "Match hidden text" t) (const :tag "Open overlays" open) (const :tag "Don't match hidden text" nil)) :group 'isearch)

(defcustom isearch-hide-immediately t "\
If non-nil, re-hide an invisible match right away.
This variable makes a difference when `search-invisible' is set to `open'.
It means that after search makes some invisible text visible
to show the match, it makes the text invisible again when the match moves.
Ordinarily the text becomes invisible again at the end of the search." :type 'boolean :group 'isearch)

(defcustom search-ring-max 16 "\
*Maximum length of search ring before oldest elements are thrown away." :type 'integer :group 'isearch)

(defcustom regexp-search-ring-max 16 "\
*Maximum length of regexp search ring before oldest elements are thrown away." :type 'integer :group 'isearch)

(defcustom search-ring-update nil "\
*Non-nil if advancing or retreating in the search ring should cause search.
Default nil means edit the string from the search ring first." :type 'boolean :group 'isearch)

(defcustom isearch-highlight-all-matches search-highlight "\
*Non-nil means highlight all visible matches." :type 'boolean :group 'isearch)

;;;***

;;;### (autoloads (report-sxemacs-bug-send-init report-sxemacs-bug-no-explanations report-sxemacs-bug-no-confirmation report-sxemacs-bug-beta-extra-headers report-sxemacs-bug-beta-address report-sxemacs-bug-extra-headers report-sxemacs-bug-address sxemacsbug) "issue-tracker" "lisp/issue-tracker.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/issue-tracker.el")

(defgroup sxemacsbug nil "Sending SXEmacs bug reports." :group 'maint :group 'mail)

(defcustom report-sxemacs-bug-address "SXEmacs Devel <sxemacs-devel@sxemacs.org>" "\
*Address of mailing list for SXEmacs bugs." :group 'sxemacsbug :type 'string)

(defcustom report-sxemacs-bug-extra-headers nil "\
*An alist of mail-header value pairs for SXEmacs bugs.

It takes the format (HEADER . VALUE) where both HEADER and VALUE are
strings. See `compose-mail'." :group 'sxemacsbug :type '(repeat (cons (string :tag "Header") (string :tag "Value"))))

(defcustom report-sxemacs-bug-beta-address "SXEmacs Devel <sxemacs-devel@sxemacs.org>" "\
*Address of mailing list for SXEmacs beta bugs." :group 'sxemacsbug :type 'string)

(defcustom report-sxemacs-bug-beta-extra-headers nil "\
*An alist of mail-header value pairs for SXEmacs beta bugs.

It takes the format (HEADER . VALUE) where both HEADER and VALUE are
strings. See `compose-mail'." :group 'sxemacsbug :type '(repeat (cons (string :tag "Header") (string :tag "Value"))))

(defcustom report-sxemacs-bug-no-confirmation nil "\
*If non-nil, suppress the confirmations asked for the sake of novice users." :group 'sxemacsbug :type 'boolean)

(defcustom report-sxemacs-bug-no-explanations nil "\
*If non-nil, suppress the explanations given for the sake of novice users." :group 'sxemacsbug :type 'boolean)

(defcustom report-sxemacs-bug-send-init nil "\
*If non-nil, include the user's init.el file in the bug report." :group 'sxemacsbug :type 'boolean)

;;;***

;;;### (autoloads (keyboard) "keydefs" "lisp/keydefs.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/keydefs.el")

(defgroup keyboard nil "Input from the keyboard." :group 'environment)

;;;***

;;;### (autoloads (ldap-coding-system ldap-default-attribute-decoder ldap-ignore-attribute-codings ldap-verbose ldap-host-parameters-alist ldap-default-base ldap-default-port ldap-default-host ldap) "ldap" "lisp/ldap.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/ldap.el")

(defgroup ldap nil "Lightweight Directory Access Protocol" :group 'comm)

(defcustom ldap-default-host nil "\
*Default LDAP server hostname.
A TCP port number can be appended to that name using a colon as
a separator." :type '(choice (string :tag "Host name") (const :tag "Use library default" nil)) :group 'ldap)

(defcustom ldap-default-port nil "\
*Default TCP port for LDAP connections.
Initialized from the LDAP library at build time. Default value is 389." :type '(choice (const :tag "Use library default" nil) (integer :tag "Port number")) :group 'ldap)

(defcustom ldap-default-base nil "\
*Default base for LDAP searches.
This is a string using the syntax of RFC 1779.
For instance, \"o=ACME, c=US\" limits the search to the
Acme organization in the United States." :type '(choice (const :tag "Use library default" nil) (string :tag "Search base")) :group 'ldap)

(defcustom ldap-host-parameters-alist nil "\
*Alist of host-specific options for LDAP transactions.
The format of each list element is:
\(HOST PROP1 VAL1 PROP2 VAL2 ...)
HOST is the hostname of an LDAP server (with an optional TCP port number
appended to it  using a colon as a separator).
PROPn and VALn are property/value pairs describing parameters for the server.
Valid properties include:
  `binddn' is the distinguished name of the user to bind as
    (in RFC 1779 syntax).
  `passwd' is the password to use for simple authentication.
  `auth' is the authentication method to use.
    Possible values are: `simple', `krbv41' and `krbv42'.
  `base' is the base for the search as described in RFC 1779.
  `scope' is one of the three symbols `subtree', `base' or `onelevel'.
  `deref' is one of the symbols `never', `always', `search' or `find'.
  `timelimit' is the timeout limit for the connection in seconds.
  `sizelimit' is the maximum number of matches to return." :type '(repeat :menu-tag "Host parameters" :tag "Host parameters" (list :menu-tag "Host parameters" :tag "Host parameters" :value nil (string :tag "Host name") (checklist :inline t :greedy t (list :tag "Search Base" :inline t (const :tag "Search Base" base) string) (list :tag "Binding DN" :inline t (const :tag "Binding DN" binddn) string) (list :tag "Password" :inline t (const :tag "Password" passwd) string) (list :tag "Authentication Method" :inline t (const :tag "Authentication Method" auth) (choice (const :menu-tag "None" :tag "None" nil) (const :menu-tag "Simple" :tag "Simple" simple) (const :menu-tag "Kerberos 4.1" :tag "Kerberos 4.1" krbv41) (const :menu-tag "Kerberos 4.2" :tag "Kerberos 4.2" krbv42))) (list :tag "Search Scope" :inline t (const :tag "Search Scope" scope) (choice (const :menu-tag "Default" :tag "Default" nil) (const :menu-tag "Subtree" :tag "Subtree" subtree) (const :menu-tag "Base" :tag "Base" base) (const :menu-tag "One Level" :tag "One Level" onelevel))) (list :tag "Dereferencing" :inline t (const :tag "Dereferencing" deref) (choice (const :menu-tag "Default" :tag "Default" nil) (const :menu-tag "Never" :tag "Never" never) (const :menu-tag "Always" :tag "Always" always) (const :menu-tag "When searching" :tag "When searching" search) (const :menu-tag "When locating base" :tag "When locating base" find))) (list :tag "Time Limit" :inline t (const :tag "Time Limit" timelimit) (integer :tag "(in seconds)")) (list :tag "Size Limit" :inline t (const :tag "Size Limit" sizelimit) (integer :tag "(number of records)"))))) :group 'ldap)

(defcustom ldap-verbose nil "\
*If non-nil, LDAP operations echo progress messages." :type 'boolean :group 'ldap)

(defcustom ldap-ignore-attribute-codings nil "\
*If non-nil, do not perform any encoding/decoding on LDAP attribute values." :type 'boolean :group 'ldap)

(defcustom ldap-default-attribute-decoder nil "\
*Decoder function to use for attributes whose syntax is unknown." :type 'symbol :group 'ldap)

(defcustom ldap-coding-system nil "\
*Coding system of LDAP string values.
LDAP v3 specifies the coding system of strings to be UTF-8.
Mule support is needed for this." :type 'symbol :group 'ldap)

;;;***

;;;### (autoloads (eval-interactive-verbose lisp) "lisp-mode" "lisp/lisp-mode.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/lisp-mode.el")

(defgroup lisp nil "Lisp support, including Emacs Lisp." :group 'languages :group 'development)

(defcustom eval-interactive-verbose t "\
*Non-nil means that interactive evaluation can print messages.
The messages are printed when the expression is treated differently
using `\\[eval-last-sexp]' and `\\[eval-defun]' than it than it would have been
treated noninteractively.

The printed messages are \"defvar treated as defconst\" and \"defcustom
 evaluation forced\".  See `eval-interactive' for more details." :type 'boolean :group 'lisp)

;;;***

;;;### (autoloads (parens-require-spaces defun-prompt-regexp) "lisp" "lisp/lisp.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/lisp.el")

(defcustom defun-prompt-regexp nil "\
*Non-nil => regexp to ignore, before the character that starts a defun.
This is only necessary if the opening paren or brace is not in column 0.
See `beginning-of-defun'." :type '(choice (const :tag "none" nil) regexp) :group 'lisp)

(defcustom parens-require-spaces t "\
Non-nil => `insert-parentheses' should insert whitespace as needed." :type 'boolean :group 'editing-basics :group 'lisp)

;;;***

;;;### (autoloads (buffers-menu-grouping-function buffers-menu-sort-function buffers-menu-format-buffer-line-function buffers-menu-omit-function buffers-menu-switch-to-buffer-function buffers-menu-submenus-for-groups-p complex-buffers-menu-p buffers-menu-max-size buffers-menu menu-submenu-name-format menu-submenu-max-items menu-max-items) "menubar-items" "lisp/menubar-items.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/menubar-items.el")

(defcustom menu-max-items 25 "\
*Maximum number of items in generated menus.
If number of entries in such a menu is larger than this value, split menu
into submenus of nearly equal length (see `menu-submenu-max-items').  If
nil, never split menu into submenus." :group 'menu :type '(choice (const :tag "no submenus" nil) (integer)))

(defcustom menu-submenu-max-items 20 "\
*Maximum number of items in submenus when splitting menus.
We split large menus into submenus of this many items, and then balance
them out as much as possible (otherwise the last submenu may have very few
items)." :group 'menu :type 'integer)

(defcustom menu-submenu-name-format "%-12.12s ... %.12s" "\
*Format specification of the submenu name when splitting menus.
Used by `menu-split-long-menu' if the number of entries in a menu is
larger than `menu-menu-max-items'.
This string should contain one %s for the name of the first entry and
one %s for the name of the last entry in the submenu.
If the value is a function, it should return the submenu name.  The
function is be called with two arguments, the names of the first and
the last entry in the menu." :group 'menu :type '(choice (string :tag "Format string") (function)))

(defgroup buffers-menu nil "Customization of `Buffers' menu." :group 'menu)

(defcustom buffers-menu-max-size 25 "\
*Maximum number of entries which may appear on the \"Buffers\" menu.
If this is 10, then only the ten most-recently-selected buffers will be
shown.  If this is nil, then all buffers will be shown.  Setting this to
a large number or nil will slow down menu responsiveness." :type '(choice (const :tag "Show all" nil) (integer 10)) :group 'buffers-menu)

(defcustom complex-buffers-menu-p nil "\
*If non-nil, the buffers menu will contain several commands.
Commands will be presented as submenus of each buffer line.  If this
is false, then there will be only one command: select that buffer." :type 'boolean :group 'buffers-menu)

(defcustom buffers-menu-submenus-for-groups-p nil "\
*If non-nil, the buffers menu will contain one submenu per group of buffers.
The grouping function is specified in `buffers-menu-grouping-function'.
If this is an integer, do not build submenus if the number of buffers
is not larger than this value." :type '(choice (const :tag "No Subgroups" nil) (integer :tag "Max. submenus" 10) (sexp :format "%t
" :tag "Allow Subgroups" :value t)) :group 'buffers-menu)

(defcustom buffers-menu-switch-to-buffer-function 'switch-to-buffer "\
*The function to call to select a buffer from the buffers menu.
`switch-to-buffer' is a good choice, as is `pop-to-buffer'." :type '(radio (function-item switch-to-buffer) (function-item pop-to-buffer) (function :tag "Other")) :group 'buffers-menu)

(defcustom buffers-menu-omit-function 'buffers-menu-omit-invisible-buffers "\
*If non-nil, a function specifying the buffers to omit from the buffers menu.
This is passed a buffer and should return non-nil if the buffer should be
omitted.  The default value `buffers-menu-omit-invisible-buffers' omits
buffers that are normally considered \"invisible\" (those whose name
begins with a space)." :type '(choice (const :tag "None" nil) function) :group 'buffers-menu)

(defcustom buffers-menu-format-buffer-line-function 'format-buffers-menu-line "\
*The function to call to return a string to represent a buffer in
the buffers menu.  The function is passed a buffer and a number
\(starting with 1) indicating which buffer line in the menu is being
processed and should return a string containing an accelerator
spec. (Check out `menu-item-generate-accelerator-spec' as a convenient
way of generating the accelerator specs.) The default value
`format-buffers-menu-line' just returns the name of the buffer and
uses the number as the accelerator.  Also check out
`slow-format-buffers-menu-line' which returns a whole bunch of info
about a buffer.

Note: Gross Compatibility Hack: Older versions of this function prototype
only expected one argument, not two.  We deal gracefully with such
functions by simply calling them with one argument and leaving out the
line number.  However, this may go away at any time, so make sure to
update all of your functions of this type." :type 'function :group 'buffers-menu)

(defcustom buffers-menu-sort-function 'sort-buffers-menu-by-mode-then-alphabetically "\
*If non-nil, a function to sort the list of buffers in the buffers menu.
It will be passed two arguments (two buffers to compare) and should return
t if the first is \"less\" than the second.  One possible value is
`sort-buffers-menu-alphabetically'; another is
`sort-buffers-menu-by-mode-then-alphabetically'." :type '(choice (const :tag "None" nil) function) :group 'buffers-menu)

(defcustom buffers-menu-grouping-function 'group-buffers-menu-by-mode-then-alphabetically "\
*If non-nil, a function to group buffers in the buffers menu together.
It will be passed two arguments, successive members of the sorted buffers
list after being passed through `buffers-menu-sort-function'.  It should
return non-nil if the second buffer begins a new group.  The return value
should be the name of the old group, which may be used in hierarchical
buffers menus.  The last invocation of the function contains nil as the
second argument, so that the name of the last group can be determined.

The sensible values of this function are dependent on the value specified
for `buffers-menu-sort-function'." :type '(choice (const :tag "None" nil) function) :group 'buffers-menu)

;;;***

;;;### (autoloads (menu) "menubar" "lisp/menubar.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/menubar.el")

(defgroup menu nil "Input from the menus." :group 'environment)

;;;***

;;;### (autoloads (force-dialog-box-use minibuffer-smart-completion-tracking-behavior minibuffer-history-minimum-string-length minibuffer-electric-file-name-behavior use-dialog-box minibuffer-max-depth enable-recursive-minibuffers completion-auto-help minibuffer-confirm-incomplete minibuffer-history-uniquify insert-default-directory minibuffer) "minibuf" "lisp/minibuf.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/minibuf.el")

(defgroup minibuffer nil "Controling the behavior of the minibuffer." :group 'environment)

(defcustom insert-default-directory t "\
*Non-nil means when reading a filename start with default dir in minibuffer." :type 'boolean :group 'minibuffer)

(defcustom minibuffer-history-uniquify t "\
*Non-nil means when adding an item to a minibuffer history, remove
previous occurrences of the same item from the history list first,
rather than just consing the new element onto the front of the list." :type 'boolean :group 'minibuffer)

(defcustom minibuffer-confirm-incomplete nil "\
If true, then in contexts where completing-read allows answers which
are not valid completions, an extra RET must be typed to confirm the
response.  This is helpful for catching typos, etc." :type 'boolean :group 'minibuffer)

(defcustom completion-auto-help t "\
*Non-nil means automatically provide help for invalid completion input." :type 'boolean :group 'minibuffer)

(defcustom enable-recursive-minibuffers nil "\
*Non-nil means to allow minibuffer commands while in the minibuffer.
More precisely, this variable makes a difference when the minibuffer window
is the selected window.  If you are in some other window, minibuffer commands
are allowed even if a minibuffer is active." :type 'boolean :group 'minibuffer)

(defcustom minibuffer-max-depth 1 "\
*Global maximum number of minibuffers allowed;
compare to enable-recursive-minibuffers, which is only consulted when the
minibuffer is reinvoked while it is the selected window." :type '(choice integer (const :tag "Indefinite" nil)) :group 'minibuffer)

(defcustom use-dialog-box t "\
*Variable controlling usage of the dialog box.
If nil, the dialog box will never be used, even in response to mouse events." :type 'boolean :group 'minibuffer)

(defcustom minibuffer-electric-file-name-behavior t "\
*If non-nil, slash and tilde in certain places cause immediate deletion.
These are the same places where this behavior would occur later on anyway,
in `substitute-in-file-name'." :type 'boolean :group 'minibuffer)

(defcustom minibuffer-history-minimum-string-length nil "\
*If this variable is non-nil, a string will not be added to the
minibuffer history if its length is less than that value." :type '(choice (const :tag "Any" nil) integer) :group 'minibuffer)

(defcustom minibuffer-smart-completion-tracking-behavior nil "\
*If non-nil, look for completions under mouse in all buffers.
This allows you to click on something that looks like a completion
and have it selected, regardless of what buffer it is in.

This is not enabled by default because

-- The \"mysterious\" highlighting in normal buffers is confusing to
   people not expecting it, and looks like a bug
-- If ange-ftp is enabled, this tracking sometimes causes ange-ftp
   action as a result of mouse motion, which is *bad bad bad*.
   Hopefully this bug will be fixed at some point." :type 'boolean :group 'minibuffer)

(defcustom force-dialog-box-use nil "\
*If non-nil, always use a dialog box for asking questions, if possible.
You should *bind* this, not set it.  This is useful if you're doing
something mousy but which wasn't actually invoked using the mouse." :type 'boolean :group 'minibuffer)

;;;***

;;;### (autoloads (modeline-scrolling-method modeline-click-swaps-buffers drag-divider-event-lag modeline-3d-p modeline) "modeline" "lisp/modeline.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/modeline.el")

(defgroup modeline nil "Modeline customizations." :group 'environment)

(defcustom modeline-3d-p (let ((thickness (specifier-instance modeline-shadow-thickness))) (and (integerp thickness) (> thickness 0))) "\
Whether the default toolbar is globally visible. This option can be
customized through the options menu." :group 'display :type 'boolean :set (function (lambda (var val) (if val (set-specifier modeline-shadow-thickness 2) (set-specifier modeline-shadow-thickness 0)) (redraw-modeline t) (setq modeline-3d-p val))))

(defcustom drag-divider-event-lag 150 "\
*The pause (in msecs) between divider drag events before redisplaying.
If this value is too small, dragging will be choppy because redisplay cannot
keep up. If it is too large, dragging will be choppy because of the explicit
redisplay delay specified." :type 'integer :group 'modeline)

(defcustom modeline-click-swaps-buffers nil "\
*If non-nil, clicking on the modeline changes the current buffer.
Click on the left half of the modeline cycles forward through the
buffer list and clicking on the right half cycles backward." :type 'boolean :group 'modeline)

(defcustom modeline-scrolling-method nil "\
*If non-nil, dragging the modeline with the mouse may also scroll its
text horizontally (vertical motion controls window resizing and horizontal
motion controls modeline scrolling).

With a value of t, the modeline text is scrolled in the same direction as
the mouse motion. With a value of 'scrollbar, the modeline is considered as
a scrollbar for its own text, which then moves in the opposite direction." :type '(choice (const :tag "none" nil) (const :tag "text" t) (const :tag "scrollbar" scrollbar)) :set (lambda (sym val) (set-default sym val) (when (featurep 'x) (cond ((eq val t) (set-glyph-image modeline-pointer-glyph "hand2" 'global 'x)) ((eq val 'scrollbar) (set-glyph-image modeline-pointer-glyph "fleur" 'global 'x)) (t (set-glyph-image modeline-pointer-glyph "sb_v_double_arrow" 'global 'x))))) :group 'modeline)

;;;***

;;;### (autoloads (mouse-track-activate-strokes mouse-track-scroll-delay mouse-track-multi-click-time mouse-highlight-text mouse-yank-at-point mouse-track-rectangle-p mouse) "mouse" "lisp/mouse.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/mouse.el")

(defgroup mouse nil "Window system-independent mouse support." :group 'editing)

(defcustom mouse-track-rectangle-p nil "\
*If true, then dragging out a region with the mouse selects rectangles
instead of simple start/end regions." :type 'boolean :group 'mouse)

(defcustom mouse-yank-at-point nil "\
*If non-nil, the function `mouse-yank' will yank text at the cursor location.
Otherwise, the cursor will be moved to the location of the pointer click before
text is inserted." :type 'boolean :group 'mouse)

(defcustom mouse-highlight-text 'context "\
*Choose the default double-click highlighting behavior.
If set to `context', double-click will highlight words when the mouse
 is at a word character, or a symbol if the mouse is at a symbol
 character.
If set to `word', double-click will always attempt to highlight a word.
If set to `symbol', double-click will always attempt to highlight a
 symbol (the default behavior in previous XEmacs versions)." :type '(choice (const context) (const word) (const symbol)) :group 'mouse)

(defcustom mouse-track-multi-click-time 400 "\
*Maximum number of milliseconds allowed between clicks for a multi-click.
See `mouse-track-click-hook'." :type 'integer :group 'mouse)

(defcustom mouse-track-scroll-delay 100 "\
Maximum of milliseconds between calls to `mouse-track-drag-hook'.
If the user is dragging the mouse (i.e. the button is held down and
a drag has been initiated) and does not move the mouse for this many
milliseconds, the hook will be called with t as the value of the
WAS-TIMEOUT parameter.  This can be used to implement scrolling
in a selection when the user drags the mouse out the window it
was in.

A value of nil disables the timeout feature." :type '(choice integer (const :tag "Disabled" nil)) :group 'mouse)

(defcustom mouse-track-activate-strokes '(button1-double-click button2-click) "\
List of mouse strokes that can cause \"activation\" of the text extent
under the mouse.  The exact meaning of \"activation\" is dependent on the
text clicked on and the mode of the buffer, but typically entails actions
such as following a hyperlink or selecting an entry in a completion buffer.

Possible list entries are

button1-click
button1-double-click
button1-triple-click
button1-down
button2-click
button2-double-click
button2-triple-click
button2-down

As a general rule, you should not use the \"-down\" values, because this
makes it impossible to have other simultaneous actions, such as selection." :type '(set button1-click button1-double-click button1-triple-click button1-down button2-click button2-double-click button2-triple-click button2-down) :group 'mouse)

;;;***

;;;### (autoloads (mwheel-follow-mouse mwheel-scroll-amount) "mwheel" "lisp/mwheel.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/mwheel.el")

(defcustom mwheel-scroll-amount '(5 . 1) "\
Amount to scroll windows by when spinning the mouse wheel.
This is actually a cons cell, where the first item is the amount to scroll
on a normal wheel event, and the second is the amount to scroll when the
wheel is moved with the shift key depressed.

Each item should be the number of lines to scroll, or `nil' for near
full screen.
A near full screen is `next-screen-context-lines' less than a full screen." :group 'mouse :type '(cons (choice :tag "Normal" (const :tag "Full screen" :value nil) (integer :tag "Specific # of lines")) (choice :tag "Shifted" (const :tag "Full screen" :value nil) (integer :tag "Specific # of lines"))))

(defcustom mwheel-follow-mouse nil "\
Whether the mouse wheel should scroll the window that the mouse is over.
This can be slightly disconcerting, but some people may prefer it." :group 'mouse :type 'boolean)

;;;***

;;;### (autoloads (package-get-always-update package-get-base-filename package-get-remove-copy package-get-site-release-download-sites package-get-pre-release-download-sites package-get-download-sites package-get-remote package-get-install-to-user-init-directory package-get-package-index-file-location package-get-dir package-get package-tools) "package-get" "lisp/package-get.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/package-get.el")

(defgroup package-tools nil "Tools to manipulate packages." :group 'emacs)

(defgroup package-get nil "Automatic Package Fetcher and Installer." :prefix "package-get" :group 'package-tools)

(defcustom package-get-dir (temp-directory) "\
*Where to store temporary files for staging." :tag "Temporary directory" :type 'directory :group 'package-get)

(defcustom package-get-package-index-file-location (car (split-path (or (getenv "EMACSPACKAGEPATH") user-init-directory))) "\
*The directory where the package-index file can be found." :type 'directory :group 'package-get)

(defcustom package-get-install-to-user-init-directory nil "\
*If non-nil install packages under `user-init-directory'." :type 'boolean :group 'package-get)

(defcustom package-get-remote nil "\
*The remote site to contact for downloading packages.
Format is '(site-name directory-on-site).  As a special case, `site-name'
can be `nil', in which case `directory-on-site' is treated as a local
directory." :tag "Package repository" :type '(set (choice (const :tag "None" nil) (list :tag "Local" (const :tag "Local" nil) directory) (list :tag "Remote" host-name directory))) :group 'package-get)

(defcustom package-get-download-sites '(("US (Main XEmacs Site)" "ftp.xemacs.org" "pub/xemacs/packages") ("Argentina (xmundo.net)" "xemacs.xmundo.net" "pub/mirrors/xemacs/packages") ("Australia (aarnet.edu.au)" "mirror.aarnet.edu.au" "pub/xemacs/packages") ("Australia (au.xemacs.org)" "ftp.au.xemacs.org" "pub/xemacs/packages") ("Austria (at.xemacs.org)" "ftp.at.xemacs.org" "editors/xemacs/packages") ("Belgium (be.xemacs.org)" "ftp.be.xemacs.org" "xemacs/packages") ("Brazil (br.xemacs.org)" "ftp.br.xemacs.org" "pub/xemacs/packages") ("Canada (ca.xemacs.org)" "ftp.ca.xemacs.org" "pub/Mirror/xemacs/packages") ("Canada (nrc.ca)" "ftp.nrc.ca" "pub/packages/editors/xemacs/packages") ("China (ftp.cn.xemacs.org)" "ftp.cn.xemacs.org" "pub/xemacs/packages") ("Czech Republic (cz.xemacs.org)" "ftp.cz.xemacs.org" "MIRRORS/ftp.xemacs.org/pub/xemacs/packages") ("Denmark (dk.xemacs.org)" "ftp.dk.xemacs.org" "xemacs/packages") ("Finland (fi.xemacs.org)" "ftp.fi.xemacs.org" "pub/mirrors/ftp.xemacs.org/pub/tux/xemacs/packages") ("France (fr.xemacs.org)" "ftp.fr.xemacs.org" "pub/xemacs/packages") ("France (mirror.cict.fr)" "mirror.cict.fr" "xemacs/packages") ("France (pasteur.fr)" "ftp.pasteur.fr" "pub/computing/xemacs/packages") ("Germany (de.xemacs.org)" "ftp.de.xemacs.org" "pub/ftp.xemacs.org/tux/xemacs/packages") ("Greece (gr.xemacs.org)" "ftp.gr.xemacs.org" "mirrors/XEmacs/ftp/packages") ("Hong Kong (hk.xemacs.org)" "ftp.hk.xemacs.org" "pub/xemacsftp/packages") ("Ireland (ie.xemacs.org)" "ftp.ie.xemacs.org" "mirrors/ftp.xemacs.org/pub/xemacs/packages") ("Ireland (heanet.ie)" "ftp.heanet.ie" "mirrors/ftp.xemacs.org/packages") ("Italy (it.xemacs.org)" "ftp.it.xemacs.org" "unix/packages/XEMACS/packages") ("Japan (dti.ad.jp)" "ftp.dti.ad.jp" "pub/unix/editor/xemacs/packages") ("Japan (jp.xemacs.org)" "ftp.jp.xemacs.org" "pub/text/xemacs/packages") ("Korea (kr.xemacs.org)" "ftp.kr.xemacs.org" "pub/tools/emacs/xemacs/packages") ("Netherlands (nl.xemacs.org)" "ftp.nl.xemacs.org" "pub/xemacs/ftp/packages") ("Norway (no.xemacs.org)" "ftp.no.xemacs.org" "pub/xemacs/packages") ("Portugal (pt.xemacs.org)" "ftp.pt.xemacs.org" "pub/MIRRORS/ftp.xemacs.org/packages") ("Russia (ru.xemacs.org)" "ftp.ru.xemacs.org" "pub/emacs/xemacs/packages") ("Saudi Arabia (sa.xemacs.org)" "ftp.sa.xemacs.org" "pub/xemacs.org/packages") ("Sweden (se.xemacs.org)" "ftp.se.xemacs.org" "pub/gnu/xemacs/packages") ("Switzerland (ch.xemacs.org)" "ftp.ch.xemacs.org" "mirror/xemacs/packages") ("Taiwan (ftp.tw.xemacs.org)" "ftp.tw.xemacs.org" "Unix/Editors/XEmacs/packages") ("UK (uk.xemacs.org)" "ftp.uk.xemacs.org" "sites/ftp.xemacs.org/pub/xemacs/packages") ("US (ibiblio.org)" "mirrors.ibiblio.org" "pub/mirrors/xemacs/packages") ("US (us.xemacs.org)" "ftp.us.xemacs.org" "pub/mirrors/xemacs/packages")) "\
*List of remote sites available for downloading packages.
List format is '(site-description site-name directory-on-site).
SITE-DESCRIPTION is a textual description of the site.  SITE-NAME
is the internet address of the download site.  DIRECTORY-ON-SITE
is the directory on the site in which packages may be found.
This variable is used to initialize `package-get-remote', the
variable actually used to specify package download sites." :tag "Package download sites" :type '(repeat (list (string :tag "Name") host-name directory)) :group 'package-get)

(defcustom package-get-pre-release-download-sites '(("US Pre-Releases (Main XEmacs Site)" "ftp.xemacs.org" "pub/xemacs/beta/experimental/packages") ("Argentina Pre-Releases (xmundo.net)" "xemacs.xmundo.net" "pub/mirrors/xemacs/beta/experimental/packages") ("Australia Pre-Releases (aarnet.edu.au)" "mirror.aarnet.edu.au" "pub/xemacs/beta/experimental/packages") ("Australia Pre-Releases (au.xemacs.org)" "ftp.au.xemacs.org" "pub/xemacs/beta/experimental/packages") ("Austria Pre-Releases (at.xemacs.org)" "ftp.at.xemacs.org" "editors/xemacs/beta/experimental/packages") ("Belgium Pre-Releases (be.xemacs.org)" "ftp.be.xemacs.org" "xemacs/beta/experimental/packages") ("Brazil Pre-Releases (br.xemacs.org)" "ftp.br.xemacs.org" "pub/xemacs/xemacs-21.5/experimental/packages") ("Canada Pre-Releases (ca.xemacs.org)" "ftp.ca.xemacs.org" "pub/Mirror/xemacs/beta/experimental/packages") ("Canada Pre-Releases (nrc.ca)" "ftp.nrc.ca" "pub/packages/editors/xemacs/beta/experimental/packages") ("China Pre-Releases (ftp.cn.xemacs.org)" "ftp.cn.xemacs.org" "pub/xemacs/beta/experimental/packages") ("Czech Republic Pre-Releases (cz.xemacs.org)" "ftp.cz.xemacs.org" "MIRRORS/ftp.xemacs.org/pub/xemacs/xemacs-21.5/experimental/packages") ("Denmark Pre-Releases (dk.xemacs.org)" "ftp.dk.xemacs.org" "xemacs/beta/experimental/packages") ("Finland Pre-Releases (fi.xemacs.org)" "ftp.fi.xemacs.org" "pub/mirrors/ftp.xemacs.org/pub/tux/xemacs/beta/experimental/packages") ("France Pre-Releases (fr.xemacs.org)" "ftp.fr.xemacs.org" "pub/xemacs/beta/experimental/packages") ("France Pre-Releases (mirror.cict.fr)" "mirror.cict.fr" "xemacs/beta/experimental/packages") ("France Pre-Releases (pasteur.fr)" "ftp.pasteur.fr" "pub/computing/xemacs/beta/experimental/packages") ("Germany Pre-Releases (de.xemacs.org)" "ftp.de.xemacs.org" "pub/ftp.xemacs.org/tux/xemacs/beta/experimental/packages") ("Greece Pre-Releases (gr.xemacs.org)" "ftp.gr.xemacs.org" "mirrors/XEmacs/ftp/beta/experimental/packages") ("Hong Kong Pre-Releases (hk.xemacs.org)" "ftp.hk.xemacs.org" "pub/xemacsftp/beta/experimental/packages") ("Ireland Pre-Releases (ie.xemacs.org)" "ftp.ie.xemacs.org" "mirrors/ftp.xemacs.org/pub/xemacs/beta/experimental/packages") ("Ireland Pre-Releases (heanet.ie)" "ftp.heanet.ie" "mirrors/ftp.xemacs.org/beta/experimental/packages") ("Italy Pre-Releases (it.xemacs.org)" "ftp.it.xemacs.org" "unix/packages/XEMACS/beta/experimental/packages") ("Japan Pre-Releases (dti.ad.jp)" "ftp.dti.ad.jp" "pub/unix/editor/xemacs/beta/experimental/packages") ("Japan Pre-Releases (jp.xemacs.org)" "ftp.jp.xemacs.org" "pub/text/xemacs/beta/experimental/packages") ("Korea Pre-Releases (kr.xemacs.org)" "ftp.kr.xemacs.org" "pub/tools/emacs/xemacs/beta/experimental/packages") ("Netherlands Pre-Releases (nl.xemacs.org)" "ftp.nl.xemacs.org" "pub/xemacs/ftp/beta/experimental/packages") ("Norway Pre-Releases (no.xemacs.org)" "ftp.no.xemacs.org" "pub/xemacs/beta/experimental/packages") ("Portugal Pre-Releases (pt.xemacs.org)" "ftp.pt.xemacs.org" "pub/MIRRORS/ftp.xemacs.org/beta/experimental/packages") ("Russia Pre-Releases (ru.xemacs.org)" "ftp.ru.xemacs.org" "pub/emacs/xemacs/beta/experimental/packages") ("Saudi Arabia Pre-Releases (sa.xemacs.org)" "ftp.sa.xemacs.org" "pub/xemacs.org/beta/experimental/packages") ("Sweden Pre-Releases (se.xemacs.org)" "ftp.se.xemacs.org" "pub/gnu/xemacs/beta/experimental/packages") ("Switzerland Pre-Releases (ch.xemacs.org)" "ftp.ch.xemacs.org" "mirror/xemacs/beta/experimental/packages") ("Taiwan Pre-Releases (ftp.tw.xemacs.org)" "ftp.tw.xemacs.org" "Unix/Editors/XEmacs/beta/experimental/packages") ("UK Pre-Releases (uk.xemacs.org)" "ftp.uk.xemacs.org" "sites/ftp.xemacs.org/pub/xemacs/beta/experimental/packages") ("US Pre-Releases (ibiblio.org)" "mirrors.ibiblio.org" "pub/mirrors/xemacs/beta/experimental/packages") ("US Pre-Releases (us.xemacs.org)" "ftp.us.xemacs.org" "pub/mirrors/xemacs/beta/experimental/packages")) "\
*List of remote sites available for downloading \"Pre-Release\" packages.
List format is '(site-description site-name directory-on-site).
SITE-DESCRIPTION is a textual description of the site.  SITE-NAME
is the internet address of the download site.  DIRECTORY-ON-SITE
is the directory on the site in which packages may be found.
This variable is used to initialize `package-get-remote', the
variable actually used to specify package download sites." :tag "Pre-Release Package download sites" :type '(repeat (list (string :tag "Name") host-name directory)) :group 'package-get)

(defcustom package-get-site-release-download-sites nil "\
*List of remote sites available for downloading \"Site Release\" packages.
List format is '(site-description site-name directory-on-site).
SITE-DESCRIPTION is a textual description of the site.  SITE-NAME
is the internet address of the download site.  DIRECTORY-ON-SITE
is the directory on the site in which packages may be found.
This variable is used to initialize `package-get-remote', the
variable actually used to specify package download sites." :tag "Site Release Package download sites" :type '(repeat (list (string :tag "Name") host-name directory)) :group 'package-get)

(defcustom package-get-remove-copy t "\
*After copying and installing a package, if this is t, then remove the
copy.  Otherwise, keep it around." :type 'boolean :group 'package-get)

(defcustom package-get-base-filename "package-index.LATEST.gpg" "\
*Name of the default package-get database file.
This may either be a relative path, in which case it is interpreted
with respect to `package-get-remote', or an absolute path." :type 'file :group 'package-get)

(defcustom package-get-always-update nil "\
*If Non-nil always make sure we are using the latest package index (base).
Otherwise respect the `force-current' argument of `package-get-require-base'." :type 'boolean :group 'package-get)

;;;***

;;;### (autoloads (pui-info-buffer pui-uninstalled-package-face pui-outdated-package-face pui-deleted-package-face pui-selected-package-face pui-up-to-date-package-face pui-list-verbose pui-package-install-dest-dir pui) "package-ui" "lisp/package-ui.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/package-ui.el")

(defgroup pui nil "Convenient interface to the package system." :group 'package-tools :tag "Package User interface" :prefix "pui-")

(defcustom pui-package-install-dest-dir nil "\
*If non-nil (Automatic) path to package tree to install packages in.
Otherwise, use old path for installed packages and make a guess for
new ones." :group 'pui :tag "Install Location" :type '(choice (const :tag "Automatic" nil) (directory)))

(defcustom pui-list-verbose t "\
*If non-nil, display verbose info in the package list buffer." :group 'pui :tag "Verbose Listing" :type 'boolean)

(defcustom pui-up-to-date-package-face nil "\
*The face to use for packages that are up-to-date." :group 'pui :type 'face)

(defcustom pui-selected-package-face 'bold "\
*The face to use for selected packages.
Set this to `nil' to use the `default' face." :group 'pui :type 'face)

(defcustom pui-deleted-package-face 'blue "\
*The face to use for packages marked for removal.
Set this to `nil' to use the `default' face." :group 'pui :type 'face)

(defcustom pui-outdated-package-face 'red "\
*The face to use for outdated packages.
Set this to `nil' to use the `default' face." :group 'pui :type 'face)

(defcustom pui-uninstalled-package-face 'italic "\
*The face to use for uninstalled packages.
Set this to `nil' to use the `default' face." :group 'pui :type 'face)

(defcustom pui-info-buffer "*Packages*" "\
*Buffer to use for displaying package information." :group 'pui :type 'string)

;;;***

;;;### (autoloads (printer-page-footer printer-page-header printer-name printing) "printer" "lisp/printer.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/printer.el")

(defgroup printing nil "Generic printing support." :group 'wp)

(defcustom printer-name nil "\
*Name of printer to print to.
If nil, use default." :type 'string :group 'printing)

(defcustom printer-page-header '((face bold date) nil (face bold buffer-name)) "\
*Controls printed page header.

This can be:
- nil.  Header is not printed.
- An fbound symbol or lambda expression.  The function is called with
   one parameter, a print-context object, every time the headers need
   to be set up.  It can use the function `print-context-property' to
   query the properties of this object.  The return value is treated as
   if it was literally specified: i.e. it will be reprocessed.
- A list of up to three elements, for left, center and right portions
   of the header.  Each of these can be
   - nil, not to print the portion
   - A string, which will be printed literally.
   - A predefined symbol, on of the following:
     printer-name     Name of printer being printed to
     short-file-name  File name only, no path
     long-file-name   File name with its path
     buffer-name      Buffer name
     date             Date current when printing started
     time             Time current when printing started
     page             Current printout page number, 1-based
     user-id          User logon id
     user-name        User full name
   - A list of three elements: (face FACE-NAME EXPR).  EXPR is any of the
     items given here.  The item will be displayed in the given face.
   - A cons of an extent and any of the items given here.  The item will
     be displayed using the extent's face, begin-glyph and end-glyph
     properties.
   - A list, each element of which is any of the items given here.
     Each element of the list is rendered in sequence.  For example,
     '(\"Page \" page) is rendered as \"Page 5\" on the fifth page.
   - An fbound symbol or lambda expression, called with one parameter,
     a print-context object, as above.  The return value is treated as
     if it was literally specified: i.e. it will be reprocessed." :type 'sexp :group 'printing)

(defcustom printer-page-footer '(nil (face bold ("Page " page))) "\
*Controls printed page footer.

Format is the same as `printer-page-header'." :type 'sexp :group 'printing)

;;;***

;;;### (autoloads (execute processes-basics processes) "process" "lisp/process.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/process.el")

(defgroup processes nil "Process, subshell, compilation, and job control support." :group 'external :group 'development)

(defgroup processes-basics nil "Basic stuff dealing with processes." :group 'processes)

(defgroup execute nil "Executing external commands." :group 'processes)

;;;***

;;;### (autoloads (resize-minibuffer-frame-exactly resize-minibuffer-frame-max-height resize-minibuffer-frame resize-minibuffer-window-exactly resize-minibuffer-idle-height resize-minibuffer-window-max-height resize-minibuffer-mode resize-minibuffer) "resize-minibuffer" "lisp/resize-minibuffer.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/resize-minibuffer.el")

(defgroup resize-minibuffer nil "Dynamically resize minibuffer to display entire contents" :group 'frames)

(defcustom resize-minibuffer-mode nil "\
*If non-`nil', resize the minibuffer so its entire contents are visible." :type 'boolean :require 'rsz-minibuf :group 'resize-minibuffer)

(defcustom resize-minibuffer-window-max-height nil "\
*Maximum size the minibuffer window is allowed to become.
If less than 1 or not a number, the limit is the height of the frame in
which the active minibuffer window resides." :type '(choice (const nil) integer) :group 'resize-minibuffer)

(defcustom resize-minibuffer-idle-height nil "\
When minibuffer is idle, crop its window to this height.
Must be a positive integer or nil.  nil indicates no limit.
Effective only when `undisplay-echo-area-function' respects it.  One such
function is `undisplay-echo-area-resize-window'.")

(defcustom resize-minibuffer-window-exactly t "\
*If non-`nil', make minibuffer exactly the size needed to display all its contents.
Otherwise, the minibuffer window can temporarily increase in size but
never get smaller while it is active." :type 'boolean :group 'resize-minibuffer)

(defcustom resize-minibuffer-frame nil "\
*If non-`nil' and the active minibuffer is the sole window in its frame, allow changing the frame height." :type 'boolean :group 'resize-minibuffer)

(defcustom resize-minibuffer-frame-max-height nil "\
*Maximum size the minibuffer frame is allowed to become.
If less than 1 or not a number, there is no limit.")

(defcustom resize-minibuffer-frame-exactly nil "\
*If non-`nil', make minibuffer frame exactly the size needed to display all its contents.
Otherwise, the minibuffer frame can temporarily increase in size but
never get smaller while it is active." :type 'boolean :group 'resize-minibuffer)

;;;***

;;;### (autoloads (scrollbars-visible-p) "scrollbar" "lisp/scrollbar.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/scrollbar.el")

(defcustom scrollbars-visible-p t "\
Whether the scrollbars are globally visible.
This variable can be customized through the options menu." :type 'boolean :set (lambda (var val) (set-specifier vertical-scrollbar-visible-p val) (set-specifier horizontal-scrollbar-visible-p val) (setq-default scrollbars-visible-p val)) :group 'display)

;;;***

;;;### (autoloads (display-warning-suppressed-classes display-warning-minimum-level log-warning-minimum-level undisplay-echo-area-function redisplay-echo-area-function log-message-ignore-labels log-message-ignore-regexps log-message-max-size mail-user-agent blink-matching-paren-dont-ignore-comments blink-matching-delay blink-matching-paren-distance blink-matching-paren-on-screen blink-matching-paren column-number-mode line-number-mode comment-multi-line auto-fill-inhibit-regexp fill-prefix block-comment-end block-comment-start comment-end comment-start-skip comment-start comment-column line-move-ignore-invisible goal-column track-eol block-movement-size motion-keys-for-shifted-motion unshifted-motion-keys-deselect-region shifted-motion-keys-select-region next-line-add-newlines signal-error-on-buffer-boundary global-mark-ring-max mark-ring-max mark-ring-unrecorded-commands kill-ring-max interprogram-paste-function interprogram-cut-function kill-hooks kill-whole-line backward-delete-function delete-key-deletes-forward search-caps-disable-folding warnings log-message paren-matching fill-comments killing editing-basics) "simple" "lisp/simple.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/simple.el")

(defgroup editing-basics nil "Most basic editing variables." :group 'editing)

(defgroup killing nil "Killing and yanking commands." :group 'editing)

(defgroup fill-comments nil "Indenting and filling of comments." :prefix "comment-" :group 'fill)

(defgroup paren-matching nil "Highlight (un)matching of parens and expressions." :prefix "paren-" :group 'matching)

(defgroup log-message nil "Messages logging and display customizations." :group 'minibuffer)

(defgroup warnings nil "Warnings customizations." :group 'minibuffer)

(defcustom search-caps-disable-folding t "\
*If non-nil, upper case chars disable case fold searching.
This does not apply to \"yanked\" strings." :type 'boolean :group 'editing-basics)

(defcustom delete-key-deletes-forward t "\
*If non-nil, the DEL key will erase one character forwards.
If nil, the DEL key will erase one character backwards." :type 'boolean :group 'editing-basics)

(defcustom backward-delete-function 'delete-backward-char "\
*Function called to delete backwards on a delete keypress.
If `delete-key-deletes-forward' is nil, `backward-or-forward-delete-char'
calls this function to erase one character backwards.  Default value
is `delete-backward-char', with `backward-delete-char-untabify' being a
popular alternate setting." :type 'function :group 'editing-basics)

(defcustom kill-whole-line nil "\
*If non-nil, kill the whole line if point is at the beginning.
Otherwise, `kill-line' kills only up to the end of the line, but not
the terminating newline.

WARNING: This is a misnamed variable!  It should be called something
like `kill-whole-line-when-at-beginning'.  If you simply want
\\[kill-line] to kill the entire current line, bind it to the function
`kill-entire-line'.  " :type 'boolean :group 'killing)

(defcustom kill-hooks nil "\
*Functions run when something is added to the XEmacs kill ring.
These functions are called with one argument, the string most recently
cut or copied.  You can use this to, for example, make the most recent
kill become the X Clipboard selection." :type 'hook :group 'killing)

(defcustom interprogram-cut-function 'own-clipboard "\
Function to call to make a killed region available to other programs.

Most window systems provide some sort of facility for cutting and
pasting text between the windows of different programs.
This variable holds a function that Emacs calls whenever text
is put in the kill ring, to make the new kill available to other
programs.

The function takes one or two arguments.
The first argument, TEXT, is a string containing
the text which should be made available.
The second, PUSH, if non-nil means this is a \"new\" kill;
nil means appending to an \"old\" kill.

One reasonable choice is `own-clipboard' (the default)." :type '(radio (function-item :tag "Send to Clipboard" :format "%t
" own-clipboard) (const :tag "None" nil) (function :tag "Other")) :group 'killing)

(defcustom interprogram-paste-function 'get-clipboard-foreign "\
Function to call to get text cut from other programs.

Most window systems provide some sort of facility for cutting and
pasting text between the windows of different programs.
This variable holds a function that Emacs calls to obtain
text that other programs have provided for pasting.

The function should be called with no arguments.  If the function
returns nil, then no other program has provided such text, and the top
of the Emacs kill ring should be used.  If the function returns a
string, that string should be put in the kill ring as the latest kill.

Note that the function should return a string only if a program other
than Emacs has provided a string for pasting; if Emacs provided the
most recent string, the function should return nil.  If it is
difficult to tell whether Emacs or some other program provided the
current string, it is probably good enough to return nil if the string
is equal (according to `string=') to the last text Emacs provided.

Reasonable choices include `get-clipboard-foreign' (the default), and
functions calling `get-selection-foreign' (q.v.)." :type '(radio (function-item :tag "Get from Clipboard" :format "%t
" get-clipboard-foreign) (const :tag "None" nil) (function :tag "Other")) :group 'killing)

(defcustom kill-ring-max 30 "\
*Maximum length of kill ring before oldest elements are thrown away." :type 'integer :group 'killing)

(defcustom mark-ring-unrecorded-commands '(shifted-motion-commands yank mark-beginning-of-buffer mark-bob mark-defun mark-end-of-buffer mark-end-of-line mark-end-of-sentence mark-eob mark-marker mark-page mark-paragraph mark-sexp mark-whole-buffer mark-word) "\
*List of commands whose marks should not be recorded on the mark stack.
Many commands set the mark as part of their action.  Normally, all such
marks get recorded onto the mark stack.  However, this tends to clutter up
the mark stack unnecessarily.  You can control this by putting a command
onto this list.  Then, any marks set by the function will not be recorded.

The special value `shifted-motion-commands' causes marks set as a result
of selection using any shifted motion commands to not be recorded.

The value `yank' affects all yank-like commands, as well as just `yank'." :type '(repeat (choice (const :tag "shifted motion commands" shifted-motion-commands) (const :tag "functions that select text" :inline t (mark-beginning-of-buffer mark-bob mark-defun mark-end-of-buffer mark-end-of-line mark-end-of-sentence mark-eob mark-marker mark-page mark-paragraph mark-sexp mark-whole-buffer mark-word)) (const :tag "functions that paste text" yank) function)) :group 'killing)

(defcustom mark-ring-max 16 "\
*Maximum size of mark ring.  Start discarding off end if gets this big." :type 'integer :group 'killing)

(defcustom global-mark-ring-max 16 "\
*Maximum size of global mark ring.  Start discarding off end if gets this big." :type 'integer :group 'killing)

(defcustom signal-error-on-buffer-boundary t "\
*If Non-nil, beep or signal an error when moving past buffer boundary.
The commands that honor this variable are

forward-char-command
backward-char-command
next-line
previous-line
scroll-up-command
scroll-down-command" :type 'boolean :group 'editing-basics)

(defcustom next-line-add-newlines nil "\
*If non-nil, `next-line' inserts newline when the point is at end of buffer.
This behavior used to be the default, and is still default in FSF Emacs.
We think it is an unnecessary and unwanted side-effect." :type 'boolean :group 'editing-basics)

(defcustom shifted-motion-keys-select-region t "\
*If non-nil, shifted motion keys select text, like in MS Windows.

More specifically, if a keystroke that matches one of the key
specifications in `motion-keys-for-shifted-motion' is pressed along
with the Shift key, and the command invoked moves the cursor and
preserves the active region (see `zmacs-region-stays'), the
intervening text will be added to the active region.

When the region has been enabled or augmented as a result of a shifted
motion key, an unshifted motion key will normally deselect the region.
However, if `unshifted-motion-keys-deselect-region' is nil, the region
will remain active, augmented by the characters moved over by this
motion key.

This functionality is specifically interpreted in terms of keys, and
*NOT* in terms of particular commands, because that produces the most
intuitive behavior: `forward-char' will work with shifted motion
when invoked by `right' but not `C-f', and user-written motion commands
bound to motion keys will automatically work with shifted motion." :type 'boolean :group 'editing-basics)

(defcustom unshifted-motion-keys-deselect-region t "\
*If non-nil, unshifted motion keys deselect a shifted-motion region.
This only occurs after a region has been selected or augmented using
shifted motion keys (not when using the traditional set-mark-then-move
method), and has no effect if `shifted-motion-keys-select-region' is
nil." :type 'boolean :group 'editing-basics)

(defcustom motion-keys-for-shifted-motion '(left right up down (home) (control home) (meta control home) (end) (control end) (meta control end) prior next kp-left kp-right kp-up kp-down (kp-home) (control kp-home) (meta control kp-home) (kp-end) (control kp-end) (meta control kp-end) kp-prior kp-next) "\
*List of keys considered motion keys for the purpose of shifted selection.
When one of these keys is pressed along with the Shift key, and the
command invoked moves the cursor and preserves the active region (see
`zmacs-region-stays'), the intervening text will be added to the active
region.  See `shifted-motion-keys-select-region' for more details.

Each entry should be a keysym or a list (MODIFIERS ... KEYSYM),
i.e. zero or more modifiers followed by a keysym.  When a keysym alone
is given, a keystroke consisting of that keysym, with or without any
modifiers, is considered a motion key.  When the list form is given,
only a keystroke with exactly those modifiers and no others (with the
exception of the Shift key) is considered a motion key.

NOTE: Currently, the keysym cannot be a non-alphabetic character key
such as the `=/+' key.  In any case, the shifted-motion paradigm does
not make much sense with those keys.  The keysym can, however, be an
alphabetic key without problem, and you can specify the key using
either a character or a symbol, uppercase or lowercase." :type '(repeat (choice (const :tag "normal cursor-pad (\"gray\") keys" :inline t (left right up down (home) (control home) (meta control home) (end) (control end) (meta control end) prior next)) (const :tag "keypad motion keys" :inline t (kp-left kp-right kp-up kp-down (kp-home) (control kp-home) (meta control kp-home) (kp-end) (control kp-end) (meta control kp-end) kp-prior kp-next)) (const :tag "alphabetic motion keys" :inline t ((control b) (control f) (control p) (control n) (control a) (control e) (control v) (meta v) (meta b) (meta f) (meta a) (meta e) (meta m) (meta r) (meta control b) (meta control f) (meta control p) (meta control n) (meta control a) (meta control e) (meta control d) (meta control u))) symbol)) :group 'editing-basics)

(defcustom block-movement-size 6 "\
*Number of lines that \"block movement\" commands (\\[forward-block-of-lines], \\[backward-block-of-lines]) move by." :type 'integer :group 'editing-basics)

(defcustom track-eol nil "\
*Non-nil means vertical motion starting at end of line keeps to ends of lines.
This means moving to the end of each line moved onto.
The beginning of a blank line does not count as the end of a line." :type 'boolean :group 'editing-basics)

(defcustom goal-column nil "\
*Semipermanent goal column for vertical motion, as set by \\[set-goal-column], or nil." :type '(choice integer (const :tag "None" nil)) :group 'editing-basics)

(defcustom line-move-ignore-invisible nil "\
*Non-nil means \\[next-line] and \\[previous-line] ignore invisible lines.
Use with care, as it slows down movement significantly.  Outline mode sets this." :type 'boolean :group 'editing-basics)

(defcustom comment-column 32 "\
*Column to indent right-margin comments to.
Setting this variable automatically makes it local to the current buffer.
Each mode establishes a different default value for this variable; you
can set the value for a particular mode using that mode's hook." :type 'integer :group 'fill-comments)

(defcustom comment-start nil "\
*String to insert to start a new comment, or nil if no comment syntax." :type '(choice (const :tag "None" nil) string) :group 'fill-comments)

(defcustom comment-start-skip nil "\
*Regexp to match the start of a comment plus everything up to its body.
If there are any \\(...\\) pairs, the comment delimiter text is held to begin
at the place matched by the close of the first pair." :type '(choice (const :tag "None" nil) regexp) :group 'fill-comments)

(defcustom comment-end "" "\
*String to insert to end a new comment.
Should be an empty string if comments are terminated by end-of-line." :type 'string :group 'fill-comments)

(defcustom block-comment-start nil "\
*String to insert to start a new comment on a line by itself.
If nil, use `comment-start' instead.
Note that the regular expression `comment-start-skip' should skip this string
as well as the `comment-start' string." :type '(choice (const :tag "Use `comment-start'" nil) string) :group 'fill-comments)

(defcustom block-comment-end nil "\
*String to insert to end a new comment on a line by itself.
Should be an empty string if comments are terminated by end-of-line.
If nil, use `comment-end' instead." :type '(choice (const :tag "Use `comment-end'" nil) string) :group 'fill-comments)

(defcustom fill-prefix nil "\
*String for filling to insert at front of new line, or nil for none.
Setting this variable automatically makes it local to the current buffer." :type '(choice (const :tag "None" nil) string) :group 'fill)

(defcustom auto-fill-inhibit-regexp nil "\
*Regexp to match lines which should not be auto-filled." :type '(choice (const :tag "None" nil) regexp) :group 'fill)

(defcustom comment-multi-line t "\
*Non-nil means \\[indent-new-comment-line] should continue same comment
on new line, with no new terminator or starter.
This is obsolete because you might as well use \\[newline-and-indent]." :type 'boolean :group 'fill-comments)

(defcustom line-number-mode nil "\
*Non-nil means display line number in modeline." :type 'boolean :group 'editing-basics)

(defcustom column-number-mode nil "\
*Non-nil means display column number in mode line." :type 'boolean :group 'editing-basics)

(defcustom blink-matching-paren t "\
*Non-nil means show matching open-paren when close-paren is inserted." :type 'boolean :group 'paren-blinking)

(defcustom blink-matching-paren-on-screen t "\
*Non-nil means show matching open-paren when it is on screen.
nil means don't show it (but the open-paren can still be shown
when it is off screen." :type 'boolean :group 'paren-blinking)

(defcustom blink-matching-paren-distance 12000 "\
*If non-nil, is maximum distance to search for matching open-paren." :type '(choice integer (const nil)) :group 'paren-blinking)

(defcustom blink-matching-delay 1 "\
*The number of seconds that `blink-matching-open' will delay at a match." :type 'number :group 'paren-blinking)

(defcustom blink-matching-paren-dont-ignore-comments nil "\
*Non-nil means `blink-matching-paren' should not ignore comments." :type 'boolean :group 'paren-blinking)

(defcustom mail-user-agent 'sendmail-user-agent "\
*Your preference for a mail composition package.
Various Emacs Lisp packages (e.g. reporter) require you to compose an
outgoing email message.  This variable lets you specify which
mail-sending package you prefer.

Valid values include:

    sendmail-user-agent -- use the default Emacs Mail package
    mh-e-user-agent     -- use the Emacs interface to the MH mail system
    message-user-agent  -- use the GNUS mail sending package

Additional valid symbols may be available; check with the author of
your package for details." :type '(radio (function-item :tag "Default Emacs mail" :format "%t
" sendmail-user-agent) (function-item :tag "Gnus mail sending package" :format "%t
" message-user-agent) (function :tag "Other")) :group 'mail)

(defcustom log-message-max-size 50000 "\
Maximum size of the \" *Message-Log*\" buffer.  See `log-message'." :type 'integer :group 'log-message)

(defcustom log-message-ignore-regexps '("\\`\\'" "\\`\\(Beginning\\|End\\) of buffer\\'") "\
List of regular expressions matching messages which shouldn't be logged.
See `log-message'.

Ideally, packages which generate messages which might need to be ignored
should label them with 'progress, 'prompt, or 'no-log, so they can be
filtered by the log-message-ignore-labels." :type '(repeat regexp) :group 'log-message)

(defcustom log-message-ignore-labels '(help-echo command progress prompt no-log garbage-collecting auto-saving) "\
List of symbols indicating labels of messages which shouldn't be logged.
See `display-message' for some common labels.  See also `log-message'." :type '(repeat (symbol :tag "Label")) :group 'log-message)

(defcustom redisplay-echo-area-function 'redisplay-echo-area "\
The function to call to display echo area buffer." :type 'function :group 'log-message)

(defcustom undisplay-echo-area-function nil "\
The function to call to undisplay echo area buffer.
WARNING: any problem with your function is likely to result in an
uninterruptible infinite loop.  Use of custom functions is therefore not
recommended." :type '(choice (const nil) function) :group 'log-message)

(defcustom log-warning-minimum-level 'info "\
Minimum level of warnings that should be logged.
The warnings in levels below this are completely ignored, as if they never
happened.

The recognized warning levels, in decreasing order of priority, are
'emergency, 'alert, 'critical, 'error, 'warning, 'notice, 'info, and
'debug.

See also `display-warning-minimum-level'.

You can also control which warnings are displayed on a class-by-class
basis.  See `display-warning-suppressed-classes' and
`log-warning-suppressed-classes'." :type '(choice (const emergency) (const alert) (const critical) (const error) (const warning) (const notice) (const info) (const debug)) :group 'warnings)

(defcustom display-warning-minimum-level 'info "\
Minimum level of warnings that should be displayed.
The warnings in levels below this will be generated, but not
displayed.

The recognized warning levels, in decreasing order of priority, are
'emergency, 'alert, 'critical, 'error, 'warning, 'notice, 'info, and
'debug.

See also `log-warning-minimum-level'.

You can also control which warnings are displayed on a class-by-class
basis.  See `display-warning-suppressed-classes' and
`log-warning-suppressed-classes'." :type '(choice (const emergency) (const alert) (const critical) (const error) (const warning) (const notice) (const info) (const debug)) :group 'warnings)

(defcustom display-warning-suppressed-classes nil "\
List of classes of warnings that shouldn't be displayed.
If any of the CLASS symbols associated with a warning is the same as
any of the symbols listed here, the warning will not be displayed.
The warning will still logged in the *Warnings* buffer (unless also
contained in `log-warning-suppressed-classes'), but the buffer will
not be automatically popped up.

See also `log-warning-minimum-level' and `display-warning-minimum-level'." :type '(repeat symbol) :group 'warnings)

;;;***

;;;### (autoloads (default-sound-directory-list sound-extension-list default-sound-directory sound-load-list sound-default-alist sound) "sound" "lisp/sound.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/sound.el")

(defgroup sound nil "Configure SXEmacs sounds and properties" :group 'environment)

(defcustom sound-default-alist '((default :sound bass) (undefined-key :sound drum) (undefined-click :sound drum) (buffer-bound :sound drum) (read-only :sound drum) (command-error :sound bass) (y-or-n-p :sound quiet) (yes-or-no-p :sound quiet) (auto-save-error :sound whip :volume 100) (no-completion :sound whip) (isearch-failed :sound quiet) (isearch-quit :sound bass) (quit :sound quiet :volume 75) (ready :sound cuckoo) (warp :sound yeep :volume 75) (alarm :sound cuckoo :volume 100)) "\
The alist of sounds and associated error symbols.

 Used to set sound-alist in load-default-sounds." :group 'sound :type '(repeat (group (symbol :tag "Name") (checklist :inline t :greedy t (group :inline t (const :format "" :value :sound) (symbol :tag "Sound")) (group :inline t (const :format "" :value :volume) (integer :tag "Volume")) (group :inline t (const :format "" :value :pitch) (integer :tag "Pitch")) (group :inline t (const :format "" :value :duration) (integer :tag "Duration"))))))

(defcustom sound-load-list '((load-sound-file "drum-beep" 'drum) (load-sound-file "quiet-beep" 'quiet) (load-sound-file "bass-snap" 'bass 80) (load-sound-file "whip" 'whip 70) (load-sound-file "cuckoo" 'cuckoo) (load-sound-file "yeep" 'yeep) (load-sound-file "hype" 'hype 100)) "\
A list of calls to load-sound-file to be processed by load-default-sounds.

  Reference load-sound-file for more information." :group 'sound :type '(repeat (sexp :tag "Sound")))

(defcustom default-sound-directory (locate-data-directory "sounds") "\
Default directory to load a sound file from." :group 'sound :type 'directory)

(defcustom sound-extension-list (cond ((eq system-type 'linux) '(".wav" ".au" ".mp3" ".mka" ".ogg" ".aac" ".ac3" ".mp4" ".flac" ".mpc" ".mpa")) (t '(".au"))) "\
List of filename extensions to complete sound file name with." :group 'sound :type 'string)

(defcustom default-sound-directory-list (locate-data-directory-list "sounds") "\
List of directories which to search for sound files" :group 'sound :type '(repeat directory))

;;;***

;;;### (autoloads (user-mail-address mail-host-address) "startup" "lisp/startup.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/startup.el")

(defcustom mail-host-address nil "\
*Name of this machine, for purposes of naming users." :type 'string :group 'mail)

(defcustom user-mail-address nil "\
*Full mailing address of this user.
This is initialized based on `mail-host-address',
after your init file is read, in case it sets `mail-host-address'." :type 'string :group 'mail)

;;;***

;;;### (autoloads (toolbar-news-frame-plist toolbar-news-use-separate-frame toolbar-news-reader toolbar-news-commands-alist toolbar-info-frame-plist toolbar-info-use-separate-frame toolbar-mail-reader toolbar-mail-commands-alist toolbar-ispell-function toolbar-replace-function toolbar-undo-function toolbar-paste-function toolbar-copy-function toolbar-cut-function toolbar-print-function toolbar-save-function toolbar-dired-function toolbar-open-function toolbar) "toolbar-items" "lisp/toolbar-items.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/toolbar-items.el")

(defgroup toolbar nil "Configure SXEmacs Toolbar functions and properties" :group 'environment)

(defcustom toolbar-open-function 'find-file "\
*Function to call when the open icon is selected." :type '(radio (function-item find-file) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-dired-function 'dired "\
*Function to call when the dired icon is selected." :type '(radio (function-item dired) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-save-function 'save-buffer "\
*Function to call when the save icon is selected." :type '(radio (function-item save-buffer) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-print-function 'lpr-buffer "\
*Function to call when the print icon is selected." :type '(radio (function-item lpr-buffer) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-cut-function 'kill-primary-selection "\
*Function to call when the cut icon is selected." :type '(radio (function-item kill-primary-selection) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-copy-function 'copy-primary-selection "\
*Function to call when the copy icon is selected." :type '(radio (function-item copy-primary-selection) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-paste-function 'yank-clipboard-selection "\
*Function to call when the paste icon is selected." :type '(radio (function-item yank-clipboard-selection) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-undo-function 'undo "\
*Function to call when the undo icon is selected." :type '(radio (function-item undo) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-replace-function 'query-replace "\
*Function to call when the replace icon is selected." :type '(radio (function-item query-replace) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-ispell-function 'toolbar-ispell-internal "\
*Function to call when the ispell icon is selected." :type '(radio (function-item toolbar-ispell-internal) (function :tag "Other")) :group 'toolbar)

(defcustom toolbar-mail-commands-alist (backquote ((not-configured . toolbar-not-configured) (vm . vm) (gnus . gnus-no-server) (rmail . rmail) (mh . mh-rmail) (pine toolbar-external "xterm" "-e" "pine") (elm toolbar-external "xterm" "-e" "elm") (mutt toolbar-external "xterm" "-e" "mutt") (exmh toolbar-external "exmh") (netscape toolbar-external "netscape" "mailbox:") (send . mail))) "\
*Alist of mail readers and their commands.
The car of each alist element is the mail reader, and the cdr is the form
used to start it." :type '(repeat (cons :format "%v" (symbol :tag "Mailer") (function :tag "Start with"))) :group 'toolbar)

(defcustom toolbar-mail-reader 'not-configured "\
*Mail reader toolbar will invoke.
The legal values are the keys from `toolbar-mail-command-alist', which
 should be used to add new mail readers.
Mail readers known by default are vm, gnus, rmail, mh, pine, elm,
 mutt, exmh, netscape and send." :type '(choice (const :tag "Not Configured" not-configured) (const vm) (const gnus) (const rmail) (const mh) (const pine) (const elm) (const mutt) (const exmh) (const netscape) (const send) (symbol :tag "Other" :validate (lambda (wid) (if (assq (widget-value wid) toolbar-mail-commands-alist) nil (widget-put wid :error "Unknown mail reader") wid)))) :group 'toolbar)

(defcustom toolbar-info-use-separate-frame t "\
*Whether Info is invoked in a separate frame." :type 'boolean :group 'toolbar)

(defcustom toolbar-info-frame-plist (backquote (width 80 (\,@ (let ((h (plist-get default-frame-plist 'height))) (and h (backquote (height (\, h)))))))) "\
*The properties of the frame in which news is displayed." :type 'plist :group 'info)

(defcustom toolbar-news-commands-alist (backquote ((not-configured . toolbar-not-configured) (gnus . toolbar-gnus) (rn toolbar-external "xterm" "-e" "rn") (nn toolbar-external "xterm" "-e" "nn") (trn toolbar-external "xterm" "-e" "trn") (xrn toolbar-external "xrn") (slrn toolbar-external "xterm" "-e" "slrn") (pine toolbar-external "xterm" "-e" "pine") (tin toolbar-external "xterm" "-e" "tin") (netscape toolbar-external "netscape" "news:"))) "\
*Alist of news readers and their commands.
The car of each alist element the pair is the news reader, and the cdr
is the form used to start it." :type '(repeat (cons :format "%v" (symbol :tag "Reader") (sexp :tag "Start with"))) :group 'toolbar)

(defcustom toolbar-news-reader 'gnus "\
*News reader toolbar will invoke.
The legal values are the keys from `toolbar-news-command-alist', which should
 be used to add new news readers.
Newsreaders known by default are gnus, rn, nn, trn, xrn, slrn, pine
 and netscape." :type '(choice (const :tag "Not Configured" not-configured) (const gnus) (const rn) (const nn) (const trn) (const xrn) (const slrn) (const pine) (const tin) (const netscape) (symbol :tag "Other" :validate (lambda (wid) (if (assq (widget-value wid) toolbar-news-commands-alist) nil (widget-put wid :error "Unknown news reader") wid)))) :group 'toolbar)

(defcustom toolbar-news-use-separate-frame t "\
*Whether Gnus is invoked in a separate frame." :type 'boolean :group 'toolbar)

(defcustom toolbar-news-frame-plist nil "\
*The properties of the frame in which news is displayed." :type 'plist :group 'toolbar)

;;;***

;;;### (autoloads (default-toolbar-position toolbar-captioned-p toolbar-visible-p) "toolbar" "lisp/toolbar.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/toolbar.el")

(defcustom toolbar-visible-p (specifier-instance default-toolbar-visible-p) "\
Whether the default toolbar is globally visible.
This option can be customized through the options menu." :group 'display :type 'boolean :set (function (lambda (var val) (set-specifier default-toolbar-visible-p val) (setq toolbar-visible-p val))))

(defcustom toolbar-captioned-p (specifier-instance toolbar-buttons-captioned-p) "\
Whether the toolbars buttons are globally captioned.
This option can be customized through the options menu." :group 'display :type 'boolean :set (function (lambda (var val) (set-specifier toolbar-buttons-captioned-p val) (setq toolbar-captioned-p val))))

(defcustom default-toolbar-position (default-toolbar-position) "\
The location of the default toolbar.
It can be 'top, 'bottom, 'left or 'right. This option can be
customized through the options menu." :group 'display :type '(choice (const :tag "top" top) (const :tag "bottom" bottom) (const :tag "left" left) (const :tag "right" right)) :set (function (lambda (var val) (set-default-toolbar-position val) (setq default-toolbar-position val))))

;;;***

;;;### (autoloads (widget-browse-mode-hook widget-browse) "wid-browse" "lisp/wid-browse.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/wid-browse.el")

(defgroup widget-browse nil "Customization support for browsing widgets." :group 'widgets)

(defcustom widget-browse-mode-hook nil "\
Hook called when entering widget-browse-mode." :type 'hook :group 'widget-browse)

;;;***

;;;### (autoloads (widget-documentation-link-type widget-documentation-link-p widget-documentation-link-regexp widget-documentation-links widget-editable-list-gui widget-choice-toggle widget-link-suffix widget-link-prefix widget-push-button-suffix widget-push-button-prefix widget-push-button-gui widget-complete-field widget-button-suffix widget-button-prefix widget-button widget-image-file-name-suffixes widget-glyph-enable widget-glyph-directory widget-field-use-before-change widget-field-add-space widget-menu-minibuffer-flag widget-menu-max-shortcuts widget-menu-max-size widget-mouse-face widget-faces widget-documentation widgets) "wid-edit" "lisp/wid-edit.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/wid-edit.el")

(defgroup widgets nil "Customization support for the Widget Library." :link '(custom-manual "(widget)Top") :link '(url-link :tag "Development Page" "http://www.dina.kvl.dk/~abraham/custom/") :link '(emacs-library-link :tag "Lisp File" "widget.el") :prefix "widget-" :group 'extensions :group 'hypermedia)

(defgroup widget-documentation nil "Options controlling the display of documentation strings." :group 'widgets)

(defgroup widget-faces nil "Faces used by the widget library." :group 'widgets :group 'faces)

(defcustom widget-mouse-face 'highlight "\
Face used for widget buttons when the mouse is above them." :type 'face :group 'widget-faces)

(defcustom widget-menu-max-size 40 "\
Largest number of items allowed in a popup-menu.
Larger menus are read through the minibuffer." :group 'widgets :type 'integer)

(defcustom widget-menu-max-shortcuts 40 "\
Largest number of items for which it works to choose one with a character.
For a larger number of items, the minibuffer is used.
#### Not yet implemented in XEmacs." :group 'widgets :type 'integer)

(defcustom widget-menu-minibuffer-flag nil "\
*Control how to ask for a choice from the keyboard.
Non-nil means use the minibuffer;
nil means read a single character." :group 'widgets :type 'boolean)

(defcustom widget-field-add-space t "\
Non-nil means add extra space at the end of editable text fields.

Currently should be left set to `t', because without the space it becomes
impossible to edit a zero size field." :type 'boolean :group 'widgets)

(defcustom widget-field-use-before-change (and (or (> emacs-minor-version 34) (> emacs-major-version 19)) (not (string-match "XEmacs" emacs-version))) "\
Non-nil means use `before-change-functions' to track editable fields.
This enables the use of undo, but doesn't work on Emacs 19.34 and earlier.
Using before hooks also means that the :notify function can't know the
new value." :type 'boolean :group 'widgets)

(defcustom widget-glyph-directory (locate-data-directory "custom") "\
Where widget button glyphs are located.
If this variable is nil, widget will try to locate the directory
automatically." :group 'widgets :type 'directory)

(defcustom widget-glyph-enable t "\
If non nil, use glyph buttons in widgets when available." :group 'widgets :type 'boolean)

(defcustom widget-image-file-name-suffixes '((xpm ".xpm") (gif ".gif") (png ".png") (jpeg ".jpg" ".jpeg") (xbm ".xbm")) "\
Conversion alist from image formats to file name suffixes." :group 'widgets :type '(repeat (cons :format "%v" (symbol :tag "Image Format" unknown) (repeat :tag "Suffixes" (string :format "%v")))))

(defgroup widget-button nil "The look of various kinds of buttons." :group 'widgets)

(defcustom widget-button-prefix "" "\
String used as prefix for buttons." :type 'string :group 'widget-button)

(defcustom widget-button-suffix "" "\
String used as suffix for buttons." :type 'string :group 'widget-button)

(defcustom widget-complete-field (lookup-key global-map "") "\
Default function to call for completion inside fields." :options '(ispell-complete-word complete-tag lisp-complete-symbol) :type 'function :group 'widgets)

(defcustom widget-push-button-gui widget-glyph-enable "\
If non nil, use GUI push buttons when available." :group 'widgets :type 'boolean)

(defcustom widget-push-button-prefix "[" "\
String used as prefix for buttons." :type 'string :group 'widget-button)

(defcustom widget-push-button-suffix "]" "\
String used as suffix for buttons." :type 'string :group 'widget-button)

(defcustom widget-link-prefix "[" "\
String used as prefix for links." :type 'string :group 'widget-button)

(defcustom widget-link-suffix "]" "\
String used as suffix for links." :type 'string :group 'widget-button)

(defcustom widget-choice-toggle nil "\
If non-nil, a binary choice will just toggle between the values.
Otherwise, the user will explicitly have to choose between the values
when he invoked the menu." :type 'boolean :group 'widgets)

(defcustom widget-editable-list-gui nil "\
If non nil, use GUI push-buttons in editable list when available." :type 'boolean :group 'widgets)

(defcustom widget-documentation-links t "\
Add hyperlinks to documentation strings when non-nil." :type 'boolean :group 'widget-documentation)

(defcustom widget-documentation-link-regexp "`\\([^\n`' ]+\\)'" "\
Regexp for matching potential links in documentation strings.
The first group should be the link itself." :type 'regexp :group 'widget-documentation)

(defcustom widget-documentation-link-p 'intern-soft "\
Predicate used to test if a string is useful as a link.
The value should be a function.  The function will be called one
argument, a string, and should return non-nil if there should be a
link for that string." :type 'function :options '(widget-documentation-link-p) :group 'widget-documentation)

(defcustom widget-documentation-link-type 'documentation-link "\
Widget type used for links in documentation strings." :type 'symbol :group 'widget-documentation)

;;;***

;;;### (autoloads (split-width-threshold split-height-threshold pop-up-windows same-window-regexps same-window-buffer-names special-display-regexps special-display-buffer-names pop-up-frames window-config-stack-max windows) "window-xemacs" "lisp/window-xemacs.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/window-xemacs.el")

(defgroup windows nil "Windows within a frame." :group 'environment)

(defcustom window-config-stack-max 16 "\
*Maximum size of window configuration stack.
Start discarding off end if it gets this big." :type 'integer :group 'windows)

(defcustom pop-up-frames nil "\
*Non-nil means `display-buffer' should make a separate frame." :type 'boolean :group 'frames)

(defcustom special-display-buffer-names nil "\
*List of buffer names that should have their own special frames.
Displaying a buffer whose name is in this list makes a special frame for it
using `special-display-function'.

An element of the list can be a cons cell instead of just a string.
Then the car should be a buffer name, and the cdr specifies frame
parameters for creating the frame for that buffer.
More precisely, the cdr is passed as the second argument to
the function found in `special-display-function', when making that frame.
See also `special-display-regexps'." :type '(repeat (choice :value "" (string :tag "Name") (cons :menu-tag "Properties" :value ("") (string :tag "Name") (repeat :tag "Properties" (group :inline t (symbol :tag "Property") (sexp :tag "Value")))))) :group 'frames)

(defcustom special-display-regexps nil "\
*List of regexps saying which buffers should have their own special frames.
If a buffer name matches one of these regexps, it gets its own frame.
Displaying a buffer whose name is in this list makes a special frame for it
using `special-display-function'.

An element of the list can be a cons cell instead of just a string.
Then the car should be the regexp, and the cdr specifies frame
parameters for creating the frame for buffers that match.
More precisely, the cdr is passed as the second argument to
the function found in `special-display-function', when making that frame.
See also `special-display-buffer-names'." :type '(repeat (choice :value "" regexp (cons :menu-tag "Properties" :value ("") regexp (repeat :tag "Properties" (group :inline t (symbol :tag "Property") (sexp :tag "Value")))))) :group 'frames)

(defcustom same-window-buffer-names nil "\
*List of buffer names that should appear in the selected window.
Displaying one of these buffers using `display-buffer' or `pop-to-buffer'
switches to it in the selected window, rather than making it appear
in some other window.

An element of the list can be a cons cell instead of just a string.
Then the car must be a string, which specifies the buffer name.
This is for compatibility with `special-display-buffer-names';
the cdr of the cons cell is ignored.

See also `same-window-regexps'." :type '(repeat (string :tag "Name")) :group 'windows)

(defcustom same-window-regexps nil "\
*List of regexps saying which buffers should appear in the selected window.
If a buffer name matches one of these regexps, then displaying it
using `display-buffer' or `pop-to-buffer' switches to it
in the selected window, rather than making it appear in some other window.

An element of the list can be a cons cell instead of just a string.
Then the car must be a string, which specifies the buffer name.
This is for compatibility with `special-display-buffer-names';
the cdr of the cons cell is ignored.

See also `same-window-buffer-names'." :type '(repeat regexp) :group 'windows)

(defcustom pop-up-windows t "\
*Non-nil means display-buffer should make new windows." :type 'boolean :group 'windows)

(defcustom split-height-threshold 500 "\
*display-buffer would prefer to split the largest window if this large.
If there is only one window, it is split regardless of this value." :type 'integer :group 'windows)

(defcustom split-width-threshold 500 "\
*display-buffer would prefer to split the largest window if this large.
If there is only one window, it is split regardless of this value." :type 'integer :group 'windows)

;;;***

;;;### (autoloads (split-window-keep-point) "window" "lisp/window.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/window.el")

(defcustom split-window-keep-point t "\
*If non-nil, split windows keeps the original point in both children.
This is often more convenient for editing.
If nil, adjust point in each of the two windows to minimize redisplay.
This is convenient on slow terminals, but point can move strangely." :type 'boolean :group 'windows)

;;;***

;;;### (autoloads (try-oblique-before-italic-fonts) "x-faces" "lisp/x-faces.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/x-faces.el")

(defcustom try-oblique-before-italic-fonts nil "\
*If nil, italic fonts are searched before oblique fonts.
If non-nil, oblique fonts are tried before italic fonts.  This is mostly
applicable to adobe-courier fonts" :type 'boolean :group 'x)

;;;***

;;;### (autoloads (x) "x-init" "lisp/x-init.el")
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/x-init.el")

(defgroup x nil "The X Window system." :group 'environment)

;;;***
(defconst custom-define-current-source-file "../.sxemacs.source.tree/lisp/autoload.el")

(provide 'auto-custom-defines)
