;;; DO NOT MODIFY THIS FILE
(if (featurep 'ffi-autoloads) (error "Feature ffi-autoloads already loaded"))

;;;### (autoloads (curl:download& curl:download) "ffi-curl" "ffi/ffi-curl.el")

(autoload 'curl:download "ffi-curl" "\
Download the contents of URL and write them to FILE-OR-BUFFER.

Optionally you can specify keywords in OPTIONS.  The options are
keyword-value-pairs and are set via `curl:easy-setopt'.

When called interactively you can choose, with a prefix arg, to download
the HTTP header instead of the actual remote file.  Obviously this only
works with HTTP URLs.

arguments: (URL FILE-OR-BUFFER &rest OPTIONS)
" t nil)

(autoload 'curl:download& "ffi-curl" "\
Download the contents of URL and write them to FILE asynchronously.

Optionally you can specify keywords in OPTIONS.  The options are
keyword-value-pairs and are set via `curl:easy-setopt'.

When called interactively you can choose, with a prefix arg, to download
the HTTP header instead of the actual remote file.  Obviously this only
works with HTTP URLs.

After the download operation succeeded the hook `curl:download&-post-hook'
is run.  Functions in there will be called with an argument JOB.

arguments: (URL FILE-OR-BUFFER &rest OPTIONS)
" t nil)

(defvar curl:download&-post-hook nil "\
*Hook run after a `curl:download&' call.
Functions in here are called with one argument JOB containing
the job which just finished.")

;;;***

;;;### (autoloads (gcry:cipher-open gcry:md-open) "ffi-gcrypt" "ffi/ffi-gcrypt.el")

(autoload 'gcry:md-open "ffi-gcrypt" "\
Return a message digest handle, initialised by HASH-ALGO.

arguments: (&optional HASH-ALGO)
" nil nil)

(autoload 'gcry:cipher-open "ffi-gcrypt" "\
Return a symmetric cipher handle, initialised by CIPHER-ALGO.

arguments: (CIPHER-ALGO &optional MODE)
" nil nil)

;;;***

;;;### (autoloads (magic:file-type) "ffi-magic" "ffi/ffi-magic.el")

(autoload 'magic:file-type "ffi-magic" "\
Return as a string what type FILE is using libmagic.

arguments: (FILE)
" t nil)

;;;***

;;;### (autoloads (sqlite-open sqlite-file-p) "ffi-sqlite" "ffi/ffi-sqlite.el")

(autoload 'sqlite-file-p "ffi-sqlite" "\
Return non-nil if FILENAME is actually SQLite format 3 file.

arguments: (FILENAME)
" nil nil)

(autoload 'sqlite-open "ffi-sqlite" "\
Try to open SQLite dabase stored in FILE.
On success return database object.

arguments: (FILE)
" nil nil)

;;;***

;;;### (autoloads (taglib:list-all-tags taglib:put-tag taglib:get-tag) "ffi-taglib" "ffi/ffi-taglib.el")

(autoload 'taglib:get-tag "ffi-taglib" "\
Get ID3 or Vorbis comment TAG from FILE.

With a prefix arg, insert the TAG at point in the current buffer,
otherwise just display it in the echo area.

arguments: (FILE TAG)
" t nil)

(defalias (function taglib:show-tag) (function taglib:get-tag))

(autoload 'taglib:put-tag "ffi-taglib" "\
Set FILE's TAG to VALUE.

arguments: (FILE TAG VALUE)
" t nil)

(defalias (function taglib:set-tag) (function taglib:put-tag))

(autoload 'taglib:list-all-tags "ffi-taglib" "\
Display a buffer showing all the tags of FILE.

arguments: (FILE)
" t nil)

;;;***

;;;### (autoloads (Wand-file-supported-for-read-p Wand-find-file-enable Wand-display Wand-display-noselect) "ffi-wand" "ffi/ffi-wand.el")

(autoload 'Wand-display-noselect "ffi-wand" "\


arguments: (FILE)
" nil nil)

(autoload 'Wand-display "ffi-wand" "\


arguments: (FILE)
" t nil)

(autoload 'Wand-find-file-enable "ffi-wand" "\
Enable `find-file' to use `Wand-display' for supported filetypes.

arguments: ()
" nil nil)

(autoload 'Wand-file-supported-for-read-p "ffi-wand" "\
Return non-nil if Wand can decode FILE.

arguments: (FILE)
" nil nil)

;;;***

(provide 'ffi-autoloads)
