;;; DO NOT MODIFY THIS FILE
(if (featurep 'ffi-custom-defines) (error "Feature ffi-custom-defines already loaded"))

;;;### (autoloads (ffi-gcrypt) "ffi-gcrypt" "ffi/ffi-gcrypt.el")
(defconst custom-define-current-source-file "../../.sxemacs.source.tree/lisp/ffi/ffi-gcrypt.el")

(defgroup ffi-gcrypt nil "FFI bindings for libgcrypt (part of GPG)." :group 'extensions)

;;;***

;;;### (autoloads (Wand-formats-write-unsupported Wand-formats-read-unsupported Wand-mode-scaler Wand-mode-properties-pattern Wand-mode-query-for-overwrite Wand-mode-auto-rotate Wand-mode-auto-fit Wand-mode-show-operations Wand-mode-show-iptc-info Wand-mode-show-fileinfo Wand-mode-region-fill-opacity Wand-mode-region-outline-opacity Wand-mode-region-outline-width Wand-mode-region-fill-color Wand-mode-region-outline-color Wand-mode-zoom-factor Wand-mode-sigma Wand-mode-redeye-threshold Wand-mode) "ffi-wand" "ffi/ffi-wand.el")
(defconst custom-define-current-source-file "../../.sxemacs.source.tree/lisp/ffi/ffi-wand.el")

(defgroup Wand-mode nil "Group to customize Wand mode." :prefix "Wand-mode-")

(defcustom Wand-mode-redeye-threshold 1.6 "\
*Threshold to fix red eyes." :type 'float :group 'Wand-mode)

(defcustom Wand-mode-sigma 2.0 "\
*Sigma for operations such as gaussian-blur, sharpen, etc." :type 'float :group 'Wand-mode)

(defcustom Wand-mode-zoom-factor 2 "\
Default zoom in/out factor." :type 'number :group 'Wand-mode)

(defcustom Wand-mode-region-outline-color "black" "\
*Color used to outline region when selecting." :type 'color :group 'Wand-mode)

(defcustom Wand-mode-region-fill-color "white" "\
*Color used to fill region when selecting." :type 'color :group 'Wand-mode)

(defcustom Wand-mode-region-outline-width 1.3 "\
*Width of outline line for region when selecting." :type 'float :group 'Wand-mode)

(defcustom Wand-mode-region-outline-opacity 0.7 "\
*Opacity of the outline.
1.0 - Opaque
0.0 - Transparent" :type 'float :group 'Wand-mode)

(defcustom Wand-mode-region-fill-opacity 0.35 "\
*Opacity for the region when selecting.
1.0 - Opaque
0.0 - Transparent" :type 'float :group 'Wand-mode)

(defcustom Wand-mode-show-fileinfo t "\
*Non-nil to show file info on top of display." :type 'boolean :group 'Wand-mode)

(defcustom Wand-mode-show-iptc-info t "\
*Non-nil to display IPTC info if any." :type 'boolean :group 'Wand-mode)

(defcustom Wand-mode-show-operations t "\
*Non-nil to show operations done on file." :type 'boolean :group 'Wand-mode)

(defcustom Wand-mode-auto-fit t "\
*Non-nil to perform fiting to window size.
You can always toggle fitting using `Wand-mode-toggle-fit' command
\(bound to \\<Wand-mode-map>\\[Wand-mode-toggle-fit])." :type 'boolean :group 'Wand-mode)

(defcustom Wand-mode-auto-rotate t "\
*Non-nil to perform automatic rotation according to orientation.
Orientation is taken from EXIF." :type 'boolean :group 'Wand-mode)

(defcustom Wand-mode-query-for-overwrite t "\
*Non-nil to ask user when overwriting existing files." :type 'boolean :group 'Wand-mode)

(defcustom Wand-mode-properties-pattern "^exif:" "\
Pattern for properties editor." :type 'string :group 'Wand-mode)

(defcustom Wand-mode-scaler (function Wand:scale-image) "\
Function used to scale image for \"fit to size\" operation.
You could use one of `Wand:scale-image', `Wand:sample-image' or create
your own scaler with `Wand-make-scaler'." :type 'function :group 'Wand-mode)

(defcustom Wand-formats-read-unsupported '("a" "b" "c" "g" "h" "o" "k" "m" "r" "x" "y" "txt" "text" "pm") "\
List of formats that are not intented to be opened by Wand." :type '(list string) :group 'Wand-mode)

(defcustom Wand-formats-write-unsupported '("html") "\
List of formats that are not intented to be written by Wand." :type '(list string) :group 'Wand-mode)

;;;***

(provide 'ffi-custom-defines)
