;;; finder-inf.el --- keyword-to-package mapping
;; Keywords: help
;;; Commentary:
;; Don't edit this file.  It's generated by finder.el

;;; Code:

(defconst finder-package-info '(
    ("ase-heap-profs.el"
        "Benchmarks for ASE"
        (tests)
        "modules/ase/")
    ("cl-loop-profs.el"
        "Benchmarks for CL"
        (tests)
        "modules/cl/")
    ("arabic.el"
        "pre-loaded support for Arabic."
        nil
        "lisp/mule/")
    ("canna-leim.el"
        "Canna-related code for LEIM"
        (japanese  input method  leim)
        "lisp/mule/")
    ("ccl.el"
        "CCL (Code Conversion Language) compiler"
        (ccl  mule  multilingual  character set  coding-system)
        "lisp/mule/")
    ("chinese.el"
        "Support for Chinese -*- coding: iso-2022-7bit; -*-"
        (multilingual  chinese)
        "lisp/mule/")
    ("custom-load.el"
        "automatically extracted custom dependencies"
        nil
        "lisp/mule/")
    ("cyrillic.el"
        "Support for Cyrillic -*- coding: iso-2022-7bit; -*-"
        (multilingual  cyrillic)
        "lisp/mule/")
    ("english.el"
        "English support"
        (multibyte character  character set  syntax  category)
        "lisp/mule/")
    ("ethiopic.el"
        "Support for Ethiopic -*- coding: iso-2022-7bit; -*-"
        (multilingual  ethiopic)
        "lisp/mule/")
    ("european.el"
        "European languages -*- coding: iso-2022-7bit; -*-"
        (multilingual  european)
        "lisp/mule/")
    ("greek.el"
        "Support for Greek"
        (multilingual  greek)
        "lisp/mule/")
    ("hebrew.el"
        "Support for Hebrew -*- coding: iso-2022-7bit; -*-"
        (multilingual  hebrew)
        "lisp/mule/")
    ("japanese.el"
        "Japanese support -*- coding: iso-2022-7bit; -*-"
        (multilingual  japanese)
        "lisp/mule/")
    ("kinsoku.el"
        "Kinsoku (line wrap) processing for XEmacs/Mule -*- coding: iso-2022-7bit; -*-"
        nil
        "lisp/mule/")
    ("korean.el"
        "Support for Korean -*- coding: iso-2022-7bit; -*-"
        (multilingual  korean)
        "lisp/mule/")
    ("latin.el"
        "Support for Latin charsets."
        (multilingual  european  dumped)
        "lisp/mule/")
    ("misc-lang.el"
        "support for miscellaneous languages (characters)"
        (multilingual  character set  coding system)
        "lisp/mule/")
    ("mule-category.el"
        "category functions for SXEmacs/Mule."
        nil
        "lisp/mule/")
    ("mule-charset.el"
        "Charset functions for Mule."
        (i18n  mule  internal)
        "lisp/mule/")
    ("mule-cmds.el"
        "Commands for multilingual environment"
        (mule  multilingual)
        "lisp/mule/")
    ("mule-coding.el"
        "Coding-system functions for Mule."
        nil
        "lisp/mule/")
    ("mule-help.el"
        "Mule-ized Help functions"
        (help  internal  mule)
        "lisp/mule/")
    ("mule-misc.el"
        "Miscellaneous Mule functions."
        nil
        "lisp/mule/")
    ("mule-tty-init.el"
        "Initialization code for console tty under MULE"
        (mule  tty  console  dumped)
        "lisp/mule/")
    ("mule-x-init.el"
        "initialization code for X Windows under MULE"
        (mule x11)
        "lisp/mule/")
    ("thai-xtis-chars.el"
        "definition of the Thai XTIS charset."
        (mule  multilingual  thai  xtis)
        "lisp/mule/")
    ("thai-xtis.el"
        "Support for Thai (XTIS) -*- coding: iso-2022-7bit; -*-"
        (mule  multilingual  thai  xtis)
        "lisp/mule/")
    ("viet-chars.el"
        "pre-loaded support for Vietnamese, part 1."
        nil
        "lisp/mule/")
    ("vietnamese.el"
        "Support for Vietnamese -*- coding: iso-2022-7bit; -*-"
        (multilingual  vietnamese)
        "lisp/mule/")
    ("ffi-curl.el"
        "Emacs interface to libcurl."
        (ffi  curl  ftp)
        "lisp/ffi/")
    ("ffi-dbus.el"
        "FFI for D-Bus."
        (interface  ffi)
        "lisp/ffi/")
    ("ffi-gcrypt.el"
        "FFI access to libgcrypt"
        (cryptography  security)
        "lisp/ffi/")
    ("ffi-libc.el"
        "FFI bindings for libc."
        (ffi)
        "lisp/ffi/")
    ("ffi-magic.el"
        "Lisp bindings into file(1)'s libmagic.so   -*- Emacs-Lisp -*-"
        (ffi  file  magic  extension)
        "lisp/ffi/")
    ("ffi-sqlite.el"
        "FFI for sqlite3."
        (db  ffi)
        "lisp/ffi/")
    ("ffi-taglib.el"
        "SXEmacs interface to taglib"
        (ffi  taglib)
        "lisp/ffi/")
    ("ffi-wand.el"
        "SXEmacs interface to libWand."
        (ffi  wand  imagemagick)
        "lisp/ffi/")
    ("abbrev.el"
        "abbrev mode commands for Emacs"
        (abbrev  dumped)
        "lisp/")
    ("about.el"
        "the About The Authors page (shameless self promotion)."
        (extensions)
        "lisp/")
    ("alist.el"
        "utility functions about association-list"
        (alist)
        "lisp/")
    ("apropos.el"
        "apropos commands for users and programmers."
        (help)
        "lisp/")
    ("auto-save.el"
        "Safer autosaving for EFS and tmp."
        (extensions  dumped)
        "lisp/")
    ("auto-show.el"
        "perform automatic horizontal scrolling as point moves"
        (extensions  internal  dumped)
        "lisp/")
    ("autoload.el"
        "maintain autoloads in auto-autoloads files."
        (maint)
        "lisp/")
    ("backquote.el"
        "Full backquote support for elisp.  Reverse compatible too."
        (extensions  dumped)
        "lisp/")
    ("blessmail.el"
        "Decide whether movemail needs special privileges."
        (internal)
        "lisp/")
    ("buff-menu.el"
        "buffer menu main function and support functions."
        (extensions  dumped)
        "lisp/")
    ("buffer.el"
        "buffer routines taken from C"
        (internal  dumped)
        "lisp/")
    ("build-autoloads.el"
        "Guess what!"
        (internal)
        "lisp/")
    ("build-rpt.el"
        "Automatically formatted build reports for XEmacs"
        (internal)
        "lisp/")
    ("byte-optimize.el"
        "the optimization passes of the emacs-lisp byte compiler."
        (internal)
        "lisp/")
    ("bytecomp-runtime.el"
        "byte-compiler support for inlining"
        (internal  dumped)
        "lisp/")
    ("bytecomp.el"
        "compilation of Lisp code into byte code."
        (internal lisp)
        "lisp/")
    ("callers-of-rpt.el"
        "generate call graph of lisp in XEmacs"
        (internal)
        "lisp/")
    ("cl-compat.el"
        "Common Lisp extensions for GNU Emacs Lisp (compatibility)"
        (extensions)
        "lisp/")
    ("cl-extra.el"
        "Common Lisp extensions for GNU Emacs Lisp (part two)"
        (extensions  dumped)
        "lisp/")
    ("cl-macs.el"
        "Common Lisp extensions for GNU Emacs Lisp (part four)"
        (extensions)
        "lisp/")
    ("cl-seq.el"
        "Common Lisp extensions for GNU Emacs Lisp (part three)"
        (extensions  dumped)
        "lisp/")
    ("cl.el"
        "Common Lisp extensions for GNU Emacs Lisp"
        (extensions  dumped  lisp)
        "lisp/")
    ("cmdloop.el"
        "support functions for the top-level command loop."
        (internal  dumped)
        "lisp/")
    ("code-cmds.el"
        "Commands for manipulating coding systems.."
        nil
        "lisp/")
    ("code-files.el"
        "File I/O functions for XEmacs."
        nil
        "lisp/")
    ("code-process.el"
        "Process coding functions for XEmacs."
        (mule  multilingual  coding system  process)
        "lisp/")
    ("coding.el"
        "Coding-system functions for XEmacs."
        nil
        "lisp/")
    ("compat.el"
        "Mechanism for non-intrusively providing compatibility funs."
        (internal)
        "lisp/")
    ("compile-core.el"
        "Bytecompile out-of-date dumped files"
        (internal)
        "lisp/")
    ("config.el"
        "access configuration parameters"
        (configure)
        "lisp/")
    ("console.el"
        "miscellaneous console functions not written in C"
        (internal  dumped)
        "lisp/")
    ("cus-dep.el"
        "Find customization dependencies."
        (internal)
        "lisp/")
    ("cus-edit.el"
        "Tools for customizating Emacs and Lisp packages."
        (help  faces)
        "lisp/")
    ("cus-face.el"
        "Support for Custom faces."
        (help  faces)
        "lisp/")
    ("cus-file.el"
        "Manage location of the customize init file"
        (internal)
        "lisp/")
    ("cus-load.el"
        "Batch load all available cus-load files"
        (internal  help  faces)
        "lisp/")
    ("cus-start.el"
        "define customization properties of builtins."
        (internal  dumped)
        "lisp/")
    ("custom.el"
        "tools for declaring and initializing options"
        (help  faces  dumped)
        "lisp/")
    ("derived.el"
        "allow inheritance of major modes"
        (extensions  dumped)
        "lisp/")
    ("device.el"
        "miscellaneous device functions not written in C"
        (internal  dumped)
        "lisp/")
    ("dialog-items.el"
        "Dialog-box content for XEmacs"
        (content  gui  internal  dumped)
        "lisp/")
    ("dialog.el"
        "Dialog-box support for XEmacs"
        (extensions  internal  dumped)
        "lisp/")
    ("disass.el"
        "disassembler for compiled Emacs Lisp code"
        (internal)
        "lisp/")
    ("disp-table.el"
        "functions for dealing with char tables."
        (i18n  internal)
        "lisp/")
    ("dragdrop.el"
        "window system-independent Drag'n'Drop support."
        (mouse  gui  dumped)
        "lisp/")
    ("dump-paths.el"
        "set up SXEmacs paths for dumping"
        (internal  dumped)
        "lisp/")
    ("easy-mmode.el"
        "easy definition for major and minor modes"
        (extensions lisp)
        "lisp/")
    ("emod-utils.el"
        "Lisp utils for emodules   -*- Emacs-Lisp -*-"
        (util  module  emodule  dumped)
        "lisp/")
    ("etags.el"
        "etags facility for Emacs"
        (tools)
        "lisp/")
    ("events.el"
        "event functions for XEmacs."
        (internal  event  dumped)
        "lisp/")
    ("extents.el"
        "miscellaneous extent functions not written in C"
        (internal  dumped)
        "lisp/")
    ("faces.el"
        "Lisp interface to the C \"face\" structure"
        (faces  internal  dumped)
        "lisp/")
    ("ffi.el"
        "FFI lisp layer."
        (lisp  ffi)
        "lisp/")
    ("files-nomule.el"
        "file I/O stubs when not under Mule."
        (extensions  dumped)
        "lisp/")
    ("files.el"
        "file input and output commands for SXEmacs."
        (extensions  dumped)
        "lisp/")
    ("fill.el"
        "fill commands for SXEmacs."
        (wp  dumped)
        "lisp/")
    ("find-paths.el"
        "setup various SXEmacs paths"
        (internal  dumped)
        "lisp/")
    ("finder.el"
        "topic & keyword-based code finder"
        (help)
        "lisp/")
    ("float-sup.el"
        "detect absence of floating-point support in SXEmacs runtime"
        (internal  dumped)
        "lisp/")
    ("font-lock.el"
        "decorating source files with fonts/colors based on syntax"
        (languages  faces)
        "lisp/")
    ("font-menu.el"
        "Managing menus of fonts."
        nil
        "lisp/")
    ("font.el"
        "New font model"
        (faces)
        "lisp/")
    ("fontl-hooks.el"
        "pre-loaded stuff for font-lock."
        nil
        "lisp/")
    ("format.el"
        "read and save files in multiple formats"
        (extensions  dumped)
        "lisp/")
    ("frame.el"
        "multi-frame management independent of window systems."
        (internal  dumped)
        "lisp/")
    ("glyphs.el"
        "Lisp interface to C glyphs"
        (extensions  internal  dumped)
        "lisp/")
    ("gnuserv.el"
        "Lisp interface code between Emacs and gnuserv"
        (environment  processes  terminals)
        "lisp/")
    ("gpm.el"
        "Support the mouse when emacs run on a Linux console."
        (mouse  terminals)
        "lisp/")
    ("gui.el"
        "Basic GUI functions for SXEmacs."
        (internal  dumped)
        "lisp/")
    ("gutter-items.el"
        "Gutter content for SXEmacs."
        (frames  extensions  internal  dumped)
        "lisp/")
    ("gutter.el"
        "Gutter manipulation for SXEmacs."
        (frames  gui  internal  dumped)
        "lisp/")
    ("help-macro.el"
        "Makes command line help such as help-for-help"
        nil
        "lisp/")
    ("help-nomule.el"
        "Help functions when not in Mule"
        (help  internal  dumped)
        "lisp/")
    ("help.el"
        "help commands for SXEmacs."
        (help  internal  dumped)
        "lisp/")
    ("hyper-apropos.el"
        "Hypertext emacs lisp documentation interface."
        (lisp  tools  help  docs  matching)
        "lisp/")
    ("indent.el"
        "indentation commands for SXEmacs"
        (lisp  languages  tools  dumped)
        "lisp/")
    ("info.el"
        "info package for SXEmacs."
        (help)
        "lisp/")
    ("isearch-mode.el"
        "Incremental search minor mode."
        (extensions  dumped)
        "lisp/")
    ("iso8859-1.el"
        "Set case and syntax tables for Latin 1"
        (internal  dumped)
        "lisp/")
    ("issue-tracker.el"
        "SXEmacs Bug Reporting/Tracking"
        (bugs issues)
        "lisp/")
    ("itimer-autosave.el"
        "Autosave functions with itimers"
        (internal  dumped)
        "lisp/")
    ("keydefs.el"
        "Define standard keybindings."
        (internal  dumped)
        "lisp/")
    ("keymap.el"
        "Keymap functions for SXEmacs."
        (internals  dumped)
        "lisp/")
    ("ldap.el"
        "LDAP support for Emacs"
        (help comm)
        "lisp/")
    ("lib-complete.el"
        "Completion on the lisp search path"
        (lisp  extensions  dumped)
        "lisp/")
    ("lisp-mnt.el"
        "minor mode for Emacs Lisp maintainers"
        (docs  maint)
        "lisp/")
    ("lisp-mode.el"
        "Lisp mode, and its idiosyncratic commands."
        (lisp  languages  dumped)
        "lisp/")
    ("lisp.el"
        "Lisp editing commands for SXEmacs"
        (lisp  languages  dumped)
        "lisp/")
    ("list-mode.el"
        "Major mode for buffers containing lists of items"
        (extensions  dumped)
        "lisp/")
    ("loaddefs.el"
        "define standard autoloads of other files"
        (internal)
        "lisp/")
    ("loadhist.el"
        "lisp functions for working with feature groups"
        (internal  dumped)
        "lisp/")
    ("loadup.el"
        "load up standardly loaded Lisp files for SXEmacs."
        (internal  dumped)
        "lisp/")
    ("make-docfile.el"
        "Cache docstrings in external file"
        (internal)
        "lisp/")
    ("map-ynp.el"
        "General-purpose boolean question-asker."
        (lisp  extensions  dumped)
        "lisp/")
    ("menubar-items.el"
        "Menubar and popup-menu content for SXEmacs."
        (frames  extensions  internal  dumped)
        "lisp/")
    ("menubar.el"
        "Menubar support for SXEmacs"
        (internal  extensions  dumped)
        "lisp/")
    ("minibuf.el"
        "Minibuffer functions for SXEmacs"
        (internal  dumped)
        "lisp/")
    ("misc.el"
        "miscellaneous functions for SXEmacs"
        (extensions  dumped)
        "lisp/")
    ("mode-motion.el"
        "Mode-specific mouse-highlighting of text."
        (internal  mouse  dumped)
        "lisp/")
    ("modeline.el"
        "modeline hackery."
        (extensions  dumped)
        "lisp/")
    ("mouse.el"
        "window system-independent mouse support."
        (mouse  dumped)
        "lisp/")
    ("movemail.el"
        "move mail spool to a place where SXEmacs can munge it"
        (internal  dumped)
        "lisp/")
    ("multicast.el"
        "lisp frontend for multicast connections in SXEmacs"
        (dumped comm processes)
        "lisp/")
    ("mwheel.el"
        "Mouse support for MS intelli-mouse type mice"
        (mouse)
        "lisp/")
    ("number.el"
        "Enhanced Number Types for SXEmacs"
        (lisp  number)
        "lisp/")
    ("objects.el"
        "Lisp interface to C window-system objects"
        (faces  internal  dumped)
        "lisp/")
    ("obsolete.el"
        "obsoleteness support"
        (internal  dumped)
        "lisp/")
    ("package-admin.el"
        "Installation and Maintenance of SXEmacs packages"
        (internal)
        "lisp/")
    ("package-get.el"
        "Retrieve SXEmacs package"
        (internal)
        "lisp/")
    ("package-info.el"
        "Generate information about an SXEmacs package"
        (internal)
        "lisp/")
    ("packages.el"
        "Low level support for SXEmacs packages"
        (internal  lisp  dumped)
        "lisp/")
    ("page.el"
        "page motion commands for SXEmacs."
        (extensions  dumped)
        "lisp/")
    ("paragraphs.el"
        "paragraph and sentence parsing."
        (wp  dumped)
        "lisp/")
    ("paths.el"
        "define pathnames for use by various SXEmacs commands."
        (internal  dumped)
        "lisp/")
    ("picture.el"
        "\"Picture mode\" -- editing using quarter-plane screen model."
        nil
        "lisp/")
    ("printer.el"
        "support for hard-copy printing in SXEmacs"
        (printer  printing  internal  dumped)
        "lisp/")
    ("process.el"
        "commands for subprocesses; split out of simple.el"
        (internal  processes  dumped)
        "lisp/")
    ("rect.el"
        "rectangle functions for SXEmacs."
        (internal)
        "lisp/")
    ("regexp-opt.el"
        "generate efficient regexps to match strings"
        (strings  regexps  extensions)
        "lisp/")
    ("register.el"
        "register commands for SXEmacs."
        (internal  dumped)
        "lisp/")
    ("replace.el"
        "search and replace commands for SXEmacs."
        (dumped  matching)
        "lisp/")
    ("resize-minibuffer.el"
        "dynamically resize minibuffer to display entire contents"
        (minibuffer  window  frames  display)
        "lisp/")
    ("scrollbar.el"
        "Scrollbar support for SXEmacs"
        (internal  extensions  dumped)
        "lisp/")
    ("select.el"
        "Lisp interface to windows selections."
        (extensions  dumped)
        "lisp/")
    ("setup-paths.el"
        "setup various SXEmacs paths"
        (internal  dumped)
        "lisp/")
    ("shadow.el"
        "Locate Emacs Lisp file shadowings."
        (lisp)
        "lisp/")
    ("simple.el"
        "basic editing commands for SXEmacs"
        (lisp  extensions  internal  dumped)
        "lisp/")
    ("site-load.el"
        "Template file for site-wide XEmacs customization"
        (internal)
        "lisp/")
    ("sound.el"
        "Loading sound files in SXEmacs"
        (internal)
        "lisp/")
    ("specifier.el"
        "Lisp interface to specifiers"
        (internal  dumped)
        "lisp/")
    ("startup.el"
        "process SXEmacs shell arguments"
        (internal  dumped)
        "lisp/")
    ("subr.el"
        "basic lisp subroutines for SXEmacs"
        (extensions  dumped  internal)
        "lisp/")
    ("symbol-syntax.el"
        "find chars with symbol syntax"
        (matching)
        "lisp/")
    ("symbols.el"
        "functions for working with symbols and symbol values"
        (internal)
        "lisp/")
    ("syntax.el"
        "Syntax-table hacking stuff, moved from syntax.c"
        nil
        "lisp/")
    ("text-mode.el"
        "text mode, and its idiosyncratic commands."
        (wp  dumped)
        "lisp/")
    ("text-props.el"
        "implements properties of characters"
        (extensions  wp  faces  dumped)
        "lisp/")
    ("toolbar-items.el"
        "Static initialization of SXEmacs toolbar"
        (frames  dumped)
        "lisp/")
    ("toolbar.el"
        "Toolbar support for SXEmacs"
        (extensions  internal  dumped)
        "lisp/")
    ("tty-init.el"
        "initialization code for tty's"
        (terminals  dumped)
        "lisp/")
    ("undo-stack.el"
        "An \"undoable stack\" object."
        (extensions  dumped)
        "lisp/")
    ("update-elc-2.el"
        "Recompile remaining .el files, post-dumping"
        (internal)
        "lisp/")
    ("update-elc.el"
        "Bytecompile out-of-date dumped files"
        (internal)
        "lisp/")
    ("userlock.el"
        "handle file access contention between multiple users"
        (internal)
        "lisp/")
    ("version.el"
        "Record version number of SXEmacs."
        (internal  dumped)
        "lisp/")
    ("very-early-lisp.el"
        "Lisp support always needed by temacs"
        (internal  dumped)
        "lisp/")
    ("view-less.el"
        "Minor mode for browsing files with keybindings like `less'"
        (wp  unix)
        "lisp/")
    ("wid-browse.el"
        "Functions for browsing widgets."
        (extensions)
        "lisp/")
    ("wid-edit.el"
        "Functions for creating and using widgets."
        (extensions)
        "lisp/")
    ("widget.el"
        "a library of user interface components."
        (help  extensions  faces  hypermedia  dumped)
        "lisp/")
    ("window-xemacs.el"
        "SXEmacs window commands aside from those written in C."
        (frames  extensions  dumped)
        "lisp/")
    ("window.el"
        "SXEmacs window commands aside from those written in C."
        (frames  extensions  dumped)
        "lisp/")
    ("x-color.el"
        "X11 color definition support for SXEmacs"
        (internal  dumped)
        "lisp/")
    ("x-compose.el"
        "Compose-key processing in SXEmacs"
        (i18n)
        "lisp/")
    ("x-faces.el"
        "X-specific face frobnication, aka black magic."
        (extensions  internal  dumped)
        "lisp/")
    ("x-font-menu.el"
        "Managing menus of X fonts."
        nil
        "lisp/")
    ("x-init.el"
        "initialization code for X windows"
        (terminals  dumped)
        "lisp/")
    ("x-iso8859-1.el"
        "Mapping between X keysym names and ISO 8859-1"
        (extensions  internal  dumped)
        "lisp/")
    ("x-misc.el"
        "miscellaneous X functions."
        (extensions  dumped)
        "lisp/")
    ("x-mouse.el"
        "Mouse support for X window system."
        (mouse  dumped)
        "lisp/")
    ("x-scrollbar.el"
        "scrollbar resourcing and such."
        (extensions  dumped)
        "lisp/")
    ("x-select.el"
        "Lisp interface to X Selections."
        (extensions  dumped)
        "lisp/")
    ("x-win-sun.el"
        "runtime initialization for Sun X servers and keyboards"
        (terminals)
        "lisp/")
    ("x-win-xfree86.el"
        "runtime initialization for XFree86 servers"
        (terminals)
        "lisp/")
    ("AT386.el"
        "terminal support package for IBM AT keyboards"
        (terminals)
        "lisp/term/")
    ("apollo.el"
        "Apollo Graphics Primitive Support Functions"
        (hardware)
        "lisp/term/")
    ("bg-mouse.el"
        "SXEmacs code for BBN Bitgraph mouse."
        (hardware)
        "lisp/term/")
    ("internal.el"
        "setup support for PC keyboards and screens, internal terminal"
        nil
        "lisp/term/")
    ("keyswap.el"
        "swap BS and DEL keys"
        (terminals)
        "lisp/term/")
    ("linux.el"
        "define function key sequences for the Linux console"
        (terminals)
        "lisp/term/")
    ("lk201.el"
        "basic editing commands for SXEmacs"
        nil
        "lisp/term/")
    ("news.el"
        "keypad and function key bindings for the Sony NEWS keyboard"
        (terminals)
        "lisp/term/")
    ("scoansi.el"
        "set up key names for SCO ansi console"
        nil
        "lisp/term/")
    ("sun-mouse.el"
        "mouse handling for Sun windows"
        (hardware)
        "lisp/term/")
    ("sun.el"
        "keybinding for standard default sunterm keys"
        (terminals)
        "lisp/term/")
    ("sup-mouse.el"
        "supdup mouse support for lisp machines"
        (hardware)
        "lisp/term/")
    ("tvi970.el"
        "terminal support for the Televideo 970"
        (terminals)
        "lisp/term/")
    ("vt-control.el"
        "Common VTxxx control functions"
        (terminals)
        "lisp/term/")
    ("vt100-led.el"
        "functions for LED control on VT-100 terminals & clones."
        (hardware)
        "lisp/term/")
    ("vt100.el"
        "define VT100 function key sequences in function-key-map"
        (terminals)
        "lisp/term/")
    ("wyse50.el"
        "terminal support code for Wyse 50"
        (terminals)
        "lisp/term/")
    ("xterm.el"
        "define function key sequences for xterm"
        (terminals)
        "lisp/term/")
))

(provide 'finder-inf)

;;; finder-inf.el ends here
